<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use App\Models\Broadcast;
use App\Models\Promo;
use App\Models\User;
class BroadcastPlatforms extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'app:broadcast-platforms';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Broadcast notifications for users in the platforms.';

    /**
     * Execute the console command.
     */
    public function handle()
    {
        try {
            //Find all notification that are within the start and end date range and is an email format
            $date = date('Y-m-d');
            $notifications = Promo::where('format', 'platform')
                ->whereDate('start', '<=', $date)
                ->whereDate('end','>=', $date)
                ->where('broadcast', 1)
                // ->limit(2)
                ->get();
            if (! $notifications->isEmpty()) {
                foreach ($notifications->toArray() as $notif) {
                    $users = User::whereNull('deleted_at')->with('profile')->get();
                    foreach ($users as $user) {

                        $broadcastDone = Broadcast::where('user_id', $user->id)->where('notif_id', $notif['id'])->where('format', 'platform')->first();
                        if (is_null($broadcastDone)) {
                            $broadcast = new Broadcast();
                            $broadcast->user_id = $user->id;
                            $broadcast->notif_id = $notif['id'];
                            $broadcast->format = 'platform';
                            $broadcast->save();
                        }
                    }
                }

            }
            echo "Platform broadcasting is done.\n";
            \Log::info('Platform broadcasting is done.');

        } catch (\Exception $e) {
            \Log::error($e);
        }
    }
}
