<?php

namespace App\Helpers;

use Illuminate\Support\Str;
use App\Models\User;
use App\Models\UserProfile;
use SimpleSoftwareIO\QrCode\Facades\QrCode;
class ProfileHelper
{
    public static function generateQrString($user_id=0,$email)
    {
        return (new Utilities)->encdecData('enc', ['user_id'=>$user_id,'email'=>$email]);
    }

    public static function generateQrCode($qrstring='')
    {
        return QrCode::generate($qrstring);
    }

    public static function createProfile($new_user=[], $data=[])
    {
        try {
            $profile = UserProfile::where('user_id', $new_user->id)->first();
            if (is_null($profile)) {
                $profile = new UserProfile();
            }

            $six_digit_random_number = random_int(100000, 999999);
            $profile->user_id = $new_user->id;
            $exp_username = explode('@',$new_user->email);
            $atname = trim($exp_username[0]);
            $profile->firstname = $data['firstname'];
            $profile->lastname = $data['lastname'];
            $profile->mobile = '';
            $profile->qrstring = ProfileHelper::generateQrString($profile->user_id, $data['email']);
            $profile->display_name = $atname;
            $profile->avatar = null;
            $profile->signup_code = $six_digit_random_number;
            $profile->signup_serialize = (new Utilities)->encdecData('en', $profile);
            $profile->newsletter = isset($data['newsletter_validation']) && $data['newsletter_validation'] == 'yes' ? 1 : 0;
            $profile->save();

            return $profile;

        } catch (\Exception $e) {
            \Log::error($e);
        }
    }
}
