<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\API\BaseController as BaseController;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;
use Chikolokoy08\Dengine\Dengine;
use App\Models\ClaimedPromo;

class ClaimedController extends BaseController
{
    public function list(Request $request)
    {
        try {

            $data = $request->all();
            $user = $request->user();

            $dengine = new Dengine();
            $dengine::parse($data);

            //MODEL INSTANCE
            $model = new ClaimedPromo();
            $dtparams = $dengine::setParameters(['role' => $user->role, 'user_id' => $user->id]);
            //TOTAL RECORDS QUERY
            $total = count($model->getClaimsFeeds($dtparams));
            //QUERY WITH FULL PARAMETERS
            $query = $model->getClaimsFeeds($dtparams);

            //SETTER FOR TOTAL
            $dengine::recordsTotal($total);

            //PREPARING QUERY RESULT INTO DATATABLE JSON FORMAT
            $dengine::prepare($query);

            //RETURN AS JSON OBJECT
            return $dengine::make();

        } catch (\Exception $e) {
            \Log::error($e);
        }
    }
}
