<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use App\Models\PasswordReset;

class AuthController extends Controller
{
    public function __construct()
    {
        $this->middleware('guest');
    }

    public function loginView()
    {
        if (Auth::guard('sanctum')->user()) {
            return redirect()->route('dashboard');
        }
        return view('pages/login');
    }

    public function validateResetView(Request $request, $token=0)
    {
        if (Auth::guard('sanctum')->user()) {
            return redirect()->route('dashboard');
        }

        $reset_request = PasswordReset::where('token', $token)->first();
        if (is_null($reset_request)) {
            abort(404);
        } else {
            $user = \App\Models\User::where('email', $reset_request->email)->first();
            if (is_null($user)) {
                abort(404);
            }
        }

        return view('pages/reset', ['reset_request'=> $reset_request]);
    }
}
