<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use App\Helpers\Utilities;

class AuthenticatedController extends Controller
{
    protected $user;
    protected $data;

    public function __construct()
    {
        $this->middleware(function ($request, $next) {
            $this->user = \App\Models\User::where('id', \Auth::user()->id)->with('profile')->first();
            $this->data['topbar']   = $this->topBarValues();
            $this->data['user']     = $this->user;
            $this->data['sidebar']  = Utilities::menuSetter(config('menu.sidebar'));
            $this->data['notifications']  = Utilities::notificationSetter();
            return $next($request);
        });
    }

    public function topBarValues()
    {
        $user = $this->user;
        $topbarvalues = new \stdClass();
        $topbarvalues->role = !$user->role ? 'none' : $user->role ;
        return $topbarvalues;
    }
}
