<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class ClaimedPromo extends Model
{
    use HasFactory, SoftDeletes;
    protected $table = 'claimed_promos';

    protected function claimsDataQuery($whereClause='')
    {
        return "
            SELECT
                c.id,
                CONCAT(up.firstname, ' ', up.lastname) as name,
                CONCAT(cp.firstname, ' ', cp.lastname) as cashier,
                po.promo_name as promo,
                FORMAT(c.points_claimed, 0) as points,
                c.created_at as date
            FROM
                {$this->table} as c
                LEFT JOIN user_profiles as up ON up.user_id = c.user_id
                LEFT JOIN user_profiles as cp ON cp.user_id = c.cashier_id
                LEFT JOIN promotions as po ON po.id = c.promo_id
            WHERE
                {$whereClause}
        ";
    }

    public function getClaimsFeeds($qp=[])
    {
        $column_orderable 	= [ 'id', 'name', 'cashier', 'promo','points','date'];
		$qp['column_text']	= $qp['column'] == '' ? $column_orderable[0] : $column_orderable[$qp['column']];
		$qp['take']         = $qp['get_total'] == true || $qp['keyword'] != '' ? 5000000 : $qp['take'];
		$whereClause        = "ISNULL(c.deleted_at)";

        if (isset($qp['role']) && $qp['role'] == 'customer') {
            $whereClause .= " AND c.user_id = {$qp['user_id']}";
        }

		//IF KEYWORD IS NOT EMPTY
		if (!empty($qp['keyword'])) {
            $keyword = $qp['keyword'];
			$whereClause .= " AND (
                up.firstname LIKE '%$keyword%' OR up.lastname LIKE '%$keyword%' OR
                cp.firstname LIKE '%$keyword%' OR cp.lastname LIKE '%$keyword%' OR
                po.promo_name LIKE '%$keyword%'
            )";
		}

        $query = $this->claimsDataQuery($whereClause);
        $query .= "
            ORDER BY {$qp['column_text']} {$qp['order_type']}
		    LIMIT {$qp['skip']}, {$qp['take']}
        ";

        return \DB::select($query);

    }
}
