<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Promo extends Model
{
    use HasFactory, SoftDeletes;
    protected $table = 'promotions';

    protected function promoDataQuery($whereClause='')
    {
        return "
            SELECT
                n.id,
                n.promo_name,
                n.promo_details,
                n.format,
                n.rule,
                DATE_FORMAT(n.start, '%M %d, %Y') as start,
                DATE_FORMAT(n.end, '%M %d, %Y') as end,
                FORMAT(n.point_qualifications, 0) as point_qualifications,
                IF(n.broadcast, 'yes', 'no') as broadcast,
                n.created_at
            FROM
                {$this->table} as n
            WHERE
                {$whereClause}
        ";
    }

    public function getPromoFeeds($qp=[])
    {
        $column_orderable 	= [ 'id', 'promo_name', 'promo_details', 'start','end','point_qualifications','broadcast','created_at'];
		$qp['column_text']	= $qp['column'] == '' ? $column_orderable[0] : $column_orderable[$qp['column']];
		$qp['take']         = $qp['get_total'] == true || $qp['keyword'] != '' ? 5000000 : $qp['take'];
		$whereClause        = "ISNULL(n.deleted_at)";

		//IF KEYWORD IS NOT EMPTY
		if (!empty($qp['keyword'])) {
            $keyword = $qp['keyword'];
			$whereClause .= " AND (
                n.promo_name LIKE '%$keyword%' OR n.promo_details LIKE '%$keyword%' OR n.format LIKE '%$keyword%' OR
                n.rule LIKE '%$keyword%' OR n.start LIKE '%$keyword%' OR n.end LIKE '%$keyword%' OR n.point_qualifications LIKE '%$keyword%' OR
                n.broadcast LIKE '%$keyword%' OR n.created_at LIKE '%$keyword%'
            )";
		}

        $query = $this->promoDataQuery($whereClause);
        $query .= "
            ORDER BY {$qp['column_text']} {$qp['order_type']}
		    LIMIT {$qp['skip']}, {$qp['take']}
        ";

        return \DB::select($query);

    }

}
