<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Service extends Model
{
    use HasFactory, SoftDeletes;

    protected $table = 'services';

    protected function servicesDataQuery($whereClause='')
    {
        return "
            SELECT
                s.id,
                s.name,
                s.cost,
                s.points,
                IF(s.status > 0, 'Yes', 'No') as availability,
                CONCAT(up.firstname, ' ', up.lastname) as added_by,
                s.created_at
            FROM
                {$this->table} as s
                LEFT JOIN user_profiles as up ON up.user_id = s.user_id
            WHERE
                {$whereClause}
        ";
    }

    public function getServicesFeeds($qp=[])
    {
        $column_orderable 	= [ 'name', 'cost', 'points', 'availability','added_by'];
		$qp['column_text']	= $qp['column'] == '' ? $column_orderable[0] : $column_orderable[$qp['column']];
		$qp['take']         = $qp['get_total'] == true || $qp['keyword'] != '' ? 5000000 : $qp['take'];
		$whereClause        = "ISNULL(s.deleted_at)";

        // if (isset($qp['role']) && $qp['role'] == 'customer') {
        //     $whereClause .= " AND t.user_id = {$qp['user_id']}";
        // }

		//IF KEYWORD IS NOT EMPTY
		if (!empty($qp['keyword'])) {
            $keyword = $qp['keyword'];
			$whereClause .= " AND (
                u.email LIKE '%$keyword%' OR up.firstname LIKE '%$keyword%' OR up.lastname LIKE '%$keyword%' OR
                cu.email LIKE '%$keyword%' OR cp.firstname LIKE '%$keyword%' OR cp.lastname LIKE '%$keyword%'
            )";
		}

        $query = $this->servicesDataQuery($whereClause);
        $query .= "
            ORDER BY {$qp['column_text']} {$qp['order_type']}
		    LIMIT {$qp['skip']}, {$qp['take']}
        ";

        return \DB::select($query);

    }
}
