<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\SoftDeletes;

class UserProfile extends Model
{

    use HasFactory, SoftDeletes;
    protected $dates = ['deleted_at'];
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'display_name'
    ];

    /**
     * @return BelongsTo
     */
    public function user()
    {
        return $this->belongsTo('\App\Models\User');
    }

    public function profile()
    {
        return $this->belongsTo('\App\Models\Post', 'user_id', 'user_id');
    }

    public function followers()
    {
        return $this->hasMany('App\Models\Follower', 'follower_id', 'user_id');
    }

    public function followersCount()
    {
        return $this->followers()->count();
    }

    public function followings()
    {
        return $this->hasMany('App\Models\Following', 'following_id', 'user_id');
    }

    public function followingsCount()
    {
        return $this->followings()->count();
    }
}
