<?php
//Check routes/web.php for route / route name
return [
	'sidebar' => [
		[
			'type' => 'single',
			'title' => 'Dashboard',
			'icon' => 'fas fa-fw fa-tachometer-alt',
			'route' => 'dashboard',
			'id' => 'dashboard-menu',
			'status' => '',
			'divider_bottom' => true
		],
		[
			'type' => 'header',
			'title' => 'Activities',
			'status' => ''
		],
        [
			'type' => 'single',
			'title' => 'Services',
			'icon' => 'fas fa-handshake',
			'route' => 'services',
			'id' => 'services-menu',
			'status' => '',
		],
		[
			'type' => 'single',
			'title' => 'Cashiers',
			'icon' => 'fas fa-money-bill',
			'route' => 'cashiers',
			'id' => 'cashier-menu',
			'status' => '',
		],
        [
			'type' => 'single',
			'title' => 'Customers',
			'icon' => 'fas fa-fw fa-user',
			'route' => 'customers',
			'id' => 'customer-list',
			'status' => '',
		],
        [
			'type' => 'single',
			'title' => 'Transactions',
			'icon' => 'fas fa-cash-register',
			'route' => 'transactions',
			'id' => 'transaction-list',
			'status' => '',
		],
        // [
		// 	'type' => 'group',
		// 	'title' => 'Customers',
		// 	'icon' => 'fas fa-fw fa-user',
		// 	'id' => 'customer-group-menu',
		// 	'status' => '',
		// 	'items' => [
		// 		[
		// 			'title' => 'Customer List',
		// 			'route' => 'customers',
		// 			'id' => 'customer-list',
		// 			'status' => '' ,
		// 		],
        //         [
		// 			'title' => 'Transaction List',
		// 			'route' => 'transactions',
		// 			'id' => 'transaction-list',
		// 			'status' => '' ,
		// 		],
		// 	]
		// ],
        [
			'type' => 'single',
			'title' => 'Claims',
			'icon' => 'fa fa-coins',
			'route' => 'claims',
			'id' => 'claim-menu',
			'status' => '',
			'divider_bottom' => true
		],
        [
			'type' => 'single',
			'title' => 'Promos',
			'icon' => 'fas fa-fw fa-file-invoice',
			'route' => 'promos',
			'id' => 'promo-menu',
			'status' => '',
			'divider_bottom' => true
		],
	],
	//These are ID's from sidebar configs of this menu file
	'role_menus' => [
		'admin' => [
			'dashboard-menu',
            'cashier-group-menu',
			'cashier-menu',
            'customer-group-menu',
            'customer-list',
            'transaction-list',
            'promo-menu',
            'claim-menu',
            'services-menu'
		],
		'cashier' => [
			'dashboard-menu',
            'customer-group-menu',
            'customer-menu',
            'transaction-list',
            'claim-menu'
		],
		'customer' => [
			'dashboard-menu',
            'transaction-list',
            'claim-menu'
		]
	]

];
