<?php

namespace Database\Factories;

use Illuminate\Database\Eloquent\Factories\Factory;
use App\Helpers\Utilities;

/**
 * @extends \Illuminate\Database\Eloquent\Factories\Factory<\App\Models\Agent>
 */
class AgentFactory extends Factory
{
    /**
     * Define the model's default state.
     *
     * @return array<string, mixed>
     */
    public function definition(): array
    {
        $name = $this->faker->company();
        $number = (new Utilities)->numonly($this->faker->phoneNumber());
        $extra = date('Y-m-d H:i:s').$name.$number;
        $unique_key = (new Utilities)->generateHash($extra);
        return [
            'company_id' => 0,
            'unique_key' => $unique_key,
            'name' => $name,
            'number' => $number,
            'status' => 'offline',
            'last_available_at' => null
        ];
    }
}
