<?php

namespace Database\Factories;

use Illuminate\Database\Eloquent\Factories\Factory;
use App\Helpers\Utilities;

/**
 * @extends \Illuminate\Database\Eloquent\Factories\Factory<\App\Models\Call>
 */
class CallFactory extends Factory
{
    /**
     * Define the model's default state.
     *
     * @return array<string, mixed>
     */
    public function definition(): array
    {
        $name = $this->faker->name();
        $number = (new Utilities)->numonly($this->faker->phoneNumber());
        $unique_key = (new Utilities)->generateHash(date('Y-m-d H:i:s'));
        return [
            'company_id' => 0,
            'company_unique_key' => $unique_key,
            'agent_id' => 0,
            'status' => 'pending',
            'media_id' => null,
            'call_name' => $name,
            'call_number' => $number
        ];
    }
}
