<?php

namespace Database\Factories;

use Illuminate\Database\Eloquent\Factories\Factory;
use App\Helpers\Utilities;

/**
 * @extends \Illuminate\Database\Eloquent\Factories\Factory<\App\Models\Company>
 */
class CompanyFactory extends Factory
{
    /**
     * Define the model's default state.
     *
     * @return array<string, mixed>
     */
    public function definition(): array
    {
        $name = $this->faker->company();
        $address = $this->faker->address();
        $extra = date('Y-m-d H:i:s').$name.$address;
        $unique_key = (new Utilities)->generateHash($extra);
        return [
            'name' => $name,
            'address' => $address,
            'user_id' => 0,
            'unique_key' => $unique_key
        ];
    }
}
