<?php

namespace Database\Factories;

use Illuminate\Database\Eloquent\Factories\Factory;
use App\Helpers\Utilities;


class UserProfileFactory extends Factory
{
    /**
     * Define the model's default state.
     *
     * @return array
     */
    public function definition()
    {
        $chars = rand(20, 200);
        return [
            'bio' => $this->faker->realText($maxNbChars = $chars, $indexSize = 2),
            'avatar' => (new Utilities)->fakeImage('base64', '150'),
            'cover' => (new Utilities)->fakeImage('base64', '400')
        ];
    }
}
