"use strict";
(function(){
	var mod = {
		vars: {
			form: null,
			action: '',
			utils: null,
		},
		objs: {},
		init: function() {
			mod.vars.utils = window.bsutils;
            mod.notifs.init();
		},
        notifs: {
            init: function() {
                $(document).find('.notif-item').on('click', mod.notifs.call.notif);
                $(document).find('.read-all').on('click', mod.notifs.call.readall);
            },
            call: {
                notif: function(e) {
                    e.preventDefault();
                    let dis = $(this);
                    let nid = typeof dis.data('nid') != 'undefined' ? dis.data('nid') : 0 ;
                    mod.vars.utils.ajaxcall('GET', '/broadcast/detail/'+nid, {}).then(function(res) {
                        if (res.success) {
                            console.log(res);
                            let mconfig = {
                                target: 'notif-modal',
                                title: 'Promo Details',
                                form: res.data.user_form,
                                hide_btns: true
                            };
                            mod.vars.utils.modal.prep(mconfig);
                            mod.vars.utils.modal.show();
                        }
                    }, function(err){
                        console.log(err);
                        if (err.status == 406) {
                            mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                            mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                        }
                    });
                },
                readall: function(e) {
                    e.preventDefault();
                    mod.vars.utils.ajaxcall('POST', '/broadcast/readall/', {}).then(function(res) {
                        if (res.success) {
                            mod.vars.utils.prompt('success', res.message, 'Notifications');
                        }
                    }, function(err){
                        console.log(err);
                        if (err.status == 406) {
                            mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                            mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                        }
                    });
                }
            }
        }
	};
	mod.init();
	return mod;
})();
