"use strict";
(function(){
	var mod = {
		vars: {
			form: null,
			action: '',
			utils: null,
            opts: {
                // Whether to scan continuously for QR codes. If false, use scanner.scan() to manually scan.
                // If true, the scanner emits the "scan" event when a QR code is scanned. Default true.
                continuous: true,

                // The HTML element to use for the camera's video preview. Must be a <video> element.
                // When the camera is active, this element will have the "active" CSS class, otherwise,
                // it will have the "inactive" class. By default, an invisible element will be created to
                // host the video.
                video: document.getElementById('preview'),

                // Whether to horizontally mirror the video preview. This is helpful when trying to
                // scan a QR code with a user-facing camera. Default true.
                mirror: true,

                // Whether to include the scanned image data as part of the scan result. See the "scan" event
                // for image format details. Default false.
                captureImage: false,

                // Only applies to continuous mode. Whether to actively scan when the tab is not active.
                // When false, this reduces CPU usage when the tab is not active. Default true.
                backgroundScan: true,

                // Only applies to continuous mode. The period, in milliseconds, before the same QR code
                // will be recognized in succession. Default 5000 (5 seconds).
                refractoryPeriod: 5000,

                // Only applies to continuous mode. The period, in rendered frames, between scans. A lower scan period
                // increases CPU usage but makes scan response faster. Default 1 (i.e. analyze every frame).
                scanPeriod: 1
              }
		},
		objs: {
            preview_item: null,
            scanner: null
        },
        loadPreview: function(id, object) {

            return new Promise(function(resolve, reject){
                let idname = '';
                console.log(typeof id);
                console.log(typeof object);
                if (typeof id == 'undefined') {
                    window.bsutils.prompt('error', 'QRSCANNER COMPONENT: loadPreview() Id undefined', 'Oops!');
                    return false;
                }
                if (typeof object != 'object') {
                    window.bsutils.prompt('error', 'QRSCANNER COMPONENT: loadPreview() Missing object', 'Oops!');
                    return false;
                }
                if (typeof id == 'string') {
                    $('<video id="'+id+'"></video>').appendTo(object);
                    mod.objs.preview_item = $(document).find('#'+id);
                } else {
                    mod.objs.preview_item = id;
                }

                idname = mod.objs.preview_item.attr('id');
                setTimeout(function(){
                    mod.vars.opts.video = document.getElementById(idname);
                    mod.objs.scanner = new Instascan.Scanner(mod.vars.opts);
                    return resolve(mod.objs.scanner);
                }, 500);
            });

        },
        initialize: function() {

        },
	};
    window.bsqrscanner = mod;
	return mod;
})();
