/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./resources/js/global.js":
/*!********************************!*\
  !*** ./resources/js/global.js ***!
  \********************************/
/***/ (() => {



(function () {
  var mod = {
    vars: {
      form: null,
      utils: null
    },
    objs: {},
    init: function init() {
      mod.checkNavBarMobile();
    },
    checkNavBarMobile: function checkNavBarMobile() {
      if (window.matchMedia("(max-width: 767px)").matches) {
        if (!$(document).find('.sidebar').hasClass('toggled')) {
          $(document).find('#sidebarToggleTop').trigger('click');
        }
      }
    }
  };
  mod.init();
  return mod;
})();

/***/ }),

/***/ "./resources/js/utils.js":
/*!*******************************!*\
  !*** ./resources/js/utils.js ***!
  \*******************************/
/***/ (() => {



function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
(function () {
  var mod = {
    vars: {
      csrf: $(document).find('meta[name="csrf-token"]').attr('content'),
      modal_conf: {},
      preloader: $(document).find('.preloader')
    },
    objs: {
      modal_el: null,
      modal_ob: null
    },
    init: function init() {
      mod.vars.preloader.hide();
    },
    money_format: function money_format(amount, decimal_place, comma_place) {
      var re = '\\d(?=(\\d{' + (comma_place || 3) + '})+' + (decimal_place > 0 ? '\\.' : '$') + ')';
      return parseFloat(amount).toFixed(Math.max(0, ~~decimal_place)).replace(new RegExp(re, 'g'), '$&,');
    },
    number_format: function number_format(value) {
      var valid = parseFloat(value);
      var num = !valid ? '0.00' : valid.toFixed(0);
      return num.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,');
    },
    plain_number_format: function plain_number_format(value) {
      var valid = parseFloat(value);
      var num = !valid ? '0' : valid.toFixed(0);
      return num.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,');
    },
    print: function print(el, title, afterPrint) {
      el.printThis({
        pageTitle: title,
        importCSS: true,
        // import parent page css
        importStyle: true,
        // import style tags
        printContainer: true,
        printDelay: 300,
        afterPrint: afterPrint
      });
    },
    ajaxupload: function ajaxupload(path, data) {
      mod.vars.preloader.show();
      console.log(_typeof(data));

      //If serialize string add _token via concatination
      if (_typeof(data) == 'object') {
        data._token = mod.vars.csrf;
      }
      if (typeof data == 'string') {
        data += '&_token=' + mod.vars.csrf;
      }
      return new Promise(function (resolve, reject) {
        $.ajax({
          url: path,
          type: 'POST',
          cache: false,
          data: data,
          datatype: "json",
          contentType: false,
          processData: false,
          success: function success(response) {
            mod.vars.preloader.hide();
            return resolve(response);
          },
          error: function error(err) {
            mod.vars.preloader.hide();
            return reject(err);
          }
        });
      });
    },
    ajaxcall: function ajaxcall(method, path, data) {
      mod.vars.preloader.show();
      console.log(_typeof(data));

      //If serialize string add _token via concatination
      if (_typeof(data) == 'object') {
        data._token = mod.vars.csrf;
      }
      if (typeof data == 'string') {
        data += '&_token=' + mod.vars.csrf;
      }
      return new Promise(function (resolve, reject) {
        $.ajax({
          url: path,
          type: method,
          cache: false,
          data: data,
          datatype: "json",
          success: function success(response) {
            mod.vars.preloader.hide();
            return resolve(response);
          },
          error: function error(err) {
            if (err.status == 401) {
              window.location.reload();
            }
            mod.vars.preloader.hide();
            return reject(err);
          }
        });
      });
    },
    prompt: function prompt(type, message, title) {
      var modtitle = typeof title == 'undefined' ? type.toUppercase() : title;
      switch (type) {
        case 'warning':
          toastr.warning(message, modtitle);
          break;
        case 'error':
          toastr.error(message, modtitle);
          break;
        case 'success':
          toastr.success(message, modtitle);
          break;
        default:
          toastr.info(message, modtitle);
      }
    },
    showerror: function showerror(_form, message) {
      _form.append('<div class="alert alert-danger my-3">' + message + '</div>');
    },
    showprompt: function showprompt(_form, message) {
      _form.append('<div class="success success-danger my-3">' + message + '</div>');
    },
    reset: function reset(_form) {
      _form.find('.alert').remove();
      _form.find('.required').removeClass('is-invalid');
      _form.find('.required').closest('div').find('.badge').remove();
    },
    validate: function validate(_form) {
      mod.reset(_form);
      var validForm = true;
      return new Promise(function (resolve, reject) {
        _form.find('.required').each(function () {
          if ($(this).val() == '') {
            $(this).addClass('is-invalid');
            var name = $(this).attr('name');
            $(this).closest('div').append('<span class="badge badge-danger">' + name.toUpperCase() + ' is invalid.</span>');
            validForm = false;
          }
        });
        return resolve(validForm);
      });
    },
    redirect: function redirect(path) {
      window.location.href = window.location.origin + '/' + path;
    },
    removeClassStartingWith: function removeClassStartingWith(el, filter) {
      el.removeClass(function (index, className) {
        return (className.match(new RegExp("\\S*" + filter + "\\S*", 'g')) || []).join(' ');
      });
    },
    toTitleCase: function toTitleCase(str) {
      return str.replace(/\w\S*/g, function (txt) {
        return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();
      });
    },
    modal: {
      init: function init() {
        mod.modal.when.hidden();
        mod.objs.modal_ob = new bootstrap.Modal(document.getElementById(mod.vars.modal_conf.target), {
          keyboard: false,
          backdrop: 'static'
        });
      },
      prep: function prep(configs) {
        mod.vars.modal_conf = configs;
        // console.log(mod.vars.modal_conf);
        mod.objs.modal_el = $(document).find('#' + mod.vars.modal_conf.target);
        mod.objs.modal_el.find('[data-bs-dismiss="modal"]').on('click', mod.modal.hide);
        mod.modal.reset();
        mod.modal.init();
        // console.log(mod.objs.modal_ob);
        mod.objs.modal_el.find('.modal-title').html(mod.vars.modal_conf.title);
        mod.objs.modal_el.find('.modal-body').html(mod.vars.modal_conf.form);
        if (mod.vars.modal_conf.hide_btns != undefined) {
          mod.objs.modal_el.find('.modal-footer button').hide();
        }
        if (mod.vars.modal_conf.save_btn != undefined) {
          var btnPrimary = mod.objs.modal_el.find('.btn-primary');
          btnPrimary.addClass(mod.vars.modal_conf.save_btn.classes);
          btnPrimary.html(mod.vars.modal_conf.save_btn.text);
        }
        if (mod.vars.modal_conf.close_btn != undefined) {
          var _btnPrimary = mod.objs.modal_el.find('.btn-primary');
          _btnPrimary.addClass(mod.vars.modal_conf.close_btn.classes);
          _btnPrimary.html(mod.vars.modal_conf.close_btn.text);
        }
      },
      reset: function reset() {
        mod.objs.modal_el.find('.modal-title').html('');
        mod.objs.modal_el.find('.modal-body').html('<p>Modal body text goes here.</p>');
        mod.objs.modal_el.find('.modal-footer button').show();
      },
      show: function show() {
        mod.objs.modal_ob.show();
        mod.objs.modal_el.find('input:eq(0)').focus();
      },
      hide: function hide() {
        if (mod.objs.modal_ob != null) {
          mod.objs.modal_ob.hide();
        }
      },
      when: {
        shown: function shown() {},
        hidden: function hidden() {
          document.getElementById(mod.vars.modal_conf.target).addEventListener('hidden.bs.modal', function (event) {
            console.log(event);
            console.log('Modal closed');
          });
        }
      }
    },
    cookie: {
      set: function set(name, value, days) {
        var expires = "";
        if (days) {
          var date = new Date();
          date.setTime(date.getTime() + days * 24 * 60 * 60 * 1000);
          expires = "; expires=" + date.toUTCString();
        }
        document.cookie = name + "=" + (value || "") + expires + "; path=/";
      },
      get: function get(name) {
        var nameEQ = name + "=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
          var c = ca[i];
          while (c.charAt(0) == ' ') c = c.substring(1, c.length);
          if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length, c.length);
        }
        return null;
      },
      erase: function erase(name) {
        document.cookie = name + '=; Path=/; Expires=Thu, 01 Jan 1970 00:00:01 GMT;';
      }
    }
  };
  mod.init();
  window.bsutils = mod;
  return mod;
})();

/***/ }),

/***/ "./resources/scss/sb-admin-2.scss":
/*!****************************************!*\
  !*** ./resources/scss/sb-admin-2.scss ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
// extracted by mini-css-extract-plugin


/***/ }),

/***/ "./resources/scss/theme.scss":
/*!***********************************!*\
  !*** ./resources/scss/theme.scss ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
// extracted by mini-css-extract-plugin


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = __webpack_modules__;
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/chunk loaded */
/******/ 	(() => {
/******/ 		var deferred = [];
/******/ 		__webpack_require__.O = (result, chunkIds, fn, priority) => {
/******/ 			if(chunkIds) {
/******/ 				priority = priority || 0;
/******/ 				for(var i = deferred.length; i > 0 && deferred[i - 1][2] > priority; i--) deferred[i] = deferred[i - 1];
/******/ 				deferred[i] = [chunkIds, fn, priority];
/******/ 				return;
/******/ 			}
/******/ 			var notFulfilled = Infinity;
/******/ 			for (var i = 0; i < deferred.length; i++) {
/******/ 				var [chunkIds, fn, priority] = deferred[i];
/******/ 				var fulfilled = true;
/******/ 				for (var j = 0; j < chunkIds.length; j++) {
/******/ 					if ((priority & 1 === 0 || notFulfilled >= priority) && Object.keys(__webpack_require__.O).every((key) => (__webpack_require__.O[key](chunkIds[j])))) {
/******/ 						chunkIds.splice(j--, 1);
/******/ 					} else {
/******/ 						fulfilled = false;
/******/ 						if(priority < notFulfilled) notFulfilled = priority;
/******/ 					}
/******/ 				}
/******/ 				if(fulfilled) {
/******/ 					deferred.splice(i--, 1)
/******/ 					var r = fn();
/******/ 					if (r !== undefined) result = r;
/******/ 				}
/******/ 			}
/******/ 			return result;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/jsonp chunk loading */
/******/ 	(() => {
/******/ 		// no baseURI
/******/ 		
/******/ 		// object to store loaded and loading chunks
/******/ 		// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 		// [resolve, reject, Promise] = chunk loading, 0 = chunk loaded
/******/ 		var installedChunks = {
/******/ 			"/js/core": 0,
/******/ 			"css/theme": 0,
/******/ 			"css/sb-admin-2": 0
/******/ 		};
/******/ 		
/******/ 		// no chunk on demand loading
/******/ 		
/******/ 		// no prefetching
/******/ 		
/******/ 		// no preloaded
/******/ 		
/******/ 		// no HMR
/******/ 		
/******/ 		// no HMR manifest
/******/ 		
/******/ 		__webpack_require__.O.j = (chunkId) => (installedChunks[chunkId] === 0);
/******/ 		
/******/ 		// install a JSONP callback for chunk loading
/******/ 		var webpackJsonpCallback = (parentChunkLoadingFunction, data) => {
/******/ 			var [chunkIds, moreModules, runtime] = data;
/******/ 			// add "moreModules" to the modules object,
/******/ 			// then flag all "chunkIds" as loaded and fire callback
/******/ 			var moduleId, chunkId, i = 0;
/******/ 			if(chunkIds.some((id) => (installedChunks[id] !== 0))) {
/******/ 				for(moduleId in moreModules) {
/******/ 					if(__webpack_require__.o(moreModules, moduleId)) {
/******/ 						__webpack_require__.m[moduleId] = moreModules[moduleId];
/******/ 					}
/******/ 				}
/******/ 				if(runtime) var result = runtime(__webpack_require__);
/******/ 			}
/******/ 			if(parentChunkLoadingFunction) parentChunkLoadingFunction(data);
/******/ 			for(;i < chunkIds.length; i++) {
/******/ 				chunkId = chunkIds[i];
/******/ 				if(__webpack_require__.o(installedChunks, chunkId) && installedChunks[chunkId]) {
/******/ 					installedChunks[chunkId][0]();
/******/ 				}
/******/ 				installedChunks[chunkId] = 0;
/******/ 			}
/******/ 			return __webpack_require__.O(result);
/******/ 		}
/******/ 		
/******/ 		var chunkLoadingGlobal = self["webpackChunk"] = self["webpackChunk"] || [];
/******/ 		chunkLoadingGlobal.forEach(webpackJsonpCallback.bind(null, 0));
/******/ 		chunkLoadingGlobal.push = webpackJsonpCallback.bind(null, chunkLoadingGlobal.push.bind(chunkLoadingGlobal));
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module depends on other loaded chunks and execution need to be delayed
/******/ 	__webpack_require__.O(undefined, ["css/theme","css/sb-admin-2"], () => (__webpack_require__("./resources/js/global.js")))
/******/ 	__webpack_require__.O(undefined, ["css/theme","css/sb-admin-2"], () => (__webpack_require__("./resources/js/utils.js")))
/******/ 	__webpack_require__.O(undefined, ["css/theme","css/sb-admin-2"], () => (__webpack_require__("./resources/scss/sb-admin-2.scss")))
/******/ 	var __webpack_exports__ = __webpack_require__.O(undefined, ["css/theme","css/sb-admin-2"], () => (__webpack_require__("./resources/scss/theme.scss")))
/******/ 	__webpack_exports__ = __webpack_require__.O(__webpack_exports__);
/******/ 	
/******/ })()
;