"use strict";
(function(){
	var mod = {
		vars: {
			fight_table: $(document).find('#fight-table'),
			loaded_fight_table: null,
			quick_btns: $(document).find('.qb-btns'),
			bet_form: $(document).find('#place-bet'),
			bet_input: null,
			form: null,
			utils: null,
			fight_key: null,
			scan_btn: $(document).find('.scan-code'),
			claim_form: $(document).find('#claim-payout'),
			ticket_modal_el: $(document).find('#print-ticket-modal'),
			print_bind: false,
			scanned_data: null,
			ajaxdone: true,
		},
		objs: {
			fight_monitor: null,
			code_scanner: null,
			ticket_modal_obj: null,
			ticket_data: null
		},
		init: function() {
			console.log(window);
			console.log($);
			mod.vars.fight_key = fkey;
			mod.vars.utils = window.bsutils;
			mod.betForm.init();
			mod.loadQuickBets.init();
			mod.table.load();
			mod.table.monitor();
			mod.payout.init();
			mod.scanner.init();

		},
		scanner: {
			init: function() {
				let code = "";
				let reading = false;
				document.addEventListener('keypress', function(e) {
					//usually scanners throw an 'Enter' key at the end of read
					if (e.keyCode === 13) {
					      if(code.length > 10) {
					        console.log(code);
					        mod.vars.claim_form.find('[name="unique-key"]').val(code);
							mod.vars.claim_form.submit();
					        /// code ready to use                
					        code = "";
					     }
					} else {
					    code += e.key; //while this is not an 'enter' it stores the every key            
					}

					//run a timeout of 200ms at the first read and clear everything
					if(!reading) {
					    reading = true;
					    setTimeout(() => {
					        code = "";
					        reading = false;
					    }, 200);  //200 works fine for me but you can adjust it
					}
				});				
			}
		},
		loadQuickBets: {
			init: function() {
				console.log(mod.vars.quick_btns.length);
				mod.vars.quick_btns.on('click', mod.loadQuickBets.setBet);
			},
			setBet: function(e) {
				e.preventDefault();
				let dis = $(this);
				let betInputVal = mod.vars.bet_input.val();
				let amount = betInputVal != '' ? parseInt(betInputVal)+dis.data('amount') : dis.data('amount');

				mod.vars.bet_input.val(amount);
				mod.betForm.updateForm();
				
			}
		},
		table: {
			load: function() {
				$(document).ready(function(){
					let server = window.location.origin+'/datatable/fight/'+mod.vars.fight_key;
					console.log(server);
					mod.vars.loaded_fight_table = mod.vars.fight_table.DataTable({
						searching: false,
						processing: true,
	        			serverSide: true,
	        			ajax: {
	                        url: server,
	                        data: {_token:mod.vars.utils.vars.csrf},
	                        type: 'POST',
	                    },
	        			order: [[0, 'desc']],
	                    columnDefs: [{ "targets": "_all", "defaultContent": "" }],
	                    columns: [
	                    	{ "data" : "fight_number",        "title" : "Fight #",           "orderable": true, "searchable": false },
	                    	{ "data" : "formatted_meron",        "title" : "Meron",           "orderable": true, "searchable": false },
	                    	{ "data" : "formatted_wala",        "title" : "Wala",           "orderable": true, "searchable": false },
	                    	{ "data" : "formatted_status",        "title" : "Status",           "orderable": true, "searchable": false },
	                    	{ "data" : "formatted_result",        "title" : "Result",           "orderable": true, "searchable": false },
	                    ],
	                    initComplete: function(distable, data){
	                    }
					});
				});
			},
			monitor: function() {
				if (mod.objs.fight_monitor != null) {
					clearInterval(mod.objs.fight_monitor);
				}

	            mod.objs.fight_monitor = setInterval(function(){
	                if (mod.vars.loaded_fight_table != null) {
	                	// mod.vars.loaded_fight_table.ajax.reload();
	                }
	            }, 3000);				
			}
		},
		betForm: {
			init: function() {
				mod.vars.bet_input = mod.vars.bet_form.find('input[name="bet-amount"]');
				mod.vars.bet_input.val('');
				mod.vars.bet_input.on('change, keyup', mod.betForm.updateForm);
				mod.vars.bet_form.on('submit', mod.betForm.placeBet);
			},
			updateForm: function() {
				let amount = mod.vars.bet_input.val();
				let amountColor = 'info';
				//Reset first
				mod.vars.utils.removeClassStartingWith(mod.vars.bet_input, 'text-');

				if (amount >= 10000) {
					amountColor = 'danger';
				} else if (amount < 10000 && amount >= 1000) {
					amountColor = 'success';
				}
				mod.vars.bet_input.addClass('text-'+amountColor);
			},
			placeBet: function(e) {
				e.preventDefault();
				if (mod.vars.bet_input.val() == '' || mod.vars.bet_input.val() < 100) {
					mod.vars.utils.prompt('error', 'Provide valid amount. 100 or greater.', 'Place bet');
					return;
				}

				if (mod.vars.ajaxdone == true) {
					mod.vars.ajaxdone = false;
					mod.vars.utils.ajaxcall('POST', '/bet/generate', mod.vars.bet_form.serialize()).then(function(res) {
						console.log(res);
						if (res.success) {
							mod.vars.utils.prompt('success', res.message, 'Login');
							if (res.data.ticket) {
								mod.objs.ticket_data = res.data;
								let title = 'Ticket for Bet#'+mod.objs.ticket_data.bet_info.unique_key;
								mod.ticket.modal.prep({title:'Bet Ticket',ticket:mod.objs.ticket_data.ticket});
								mod.ticket.modal.show();
								mod.ticket.print.init();
							}
						}
						mod.vars.ajaxdone = true;
						mod.vars.loaded_fight_table.ajax.reload();
					}, function(err){
						console.log(err);
						if (err.status == 406) {
							mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
							mod.vars.bet_input.val('');
						}
						mod.vars.ajaxdone = true;
					});
				}
			}
		},
		payout: {
			init: function(){
				mod.payout.scanner.init();
				mod.payout.inputKey.init();				
			},
			scanner: {
				init: function() {
					mod.vars.scan_btn.on('click', mod.payout.scanner.enable);
				},
				enable: function() {
					let dis = $(this);
					dis.html('In Progress. Use Barcode Scanner');
					if ($(document).find('#scan-form').length == 0) {
						var scanForm = '<form id="scan-form" style="position:absolute;z-index: -2; bottom:0"><input type="text" value=""/></form>';
						$(scanForm).appendTo(dis);
						$(document).find('#scan-form input').focus();

						let checkInput = setInterval(function(){
							if ($(document).find('#scan-form input').val() != '') {
								console.log($(document).find('#scan-form input').val());
								dis.html('Scan is done.');
								setTimeout(function(){
									dis.html('Start Scanner');
								}, 3000);
								clearInterval(checkInput);
							}
						}, 1000);						
					}

				},
				bindListener: function() {
					Html5Qrcode.getCameras().then(devices => {
					/**
					* devices would be an array of objects of type:
					* { id: "id", label: "label" }
					*/
					if (devices && devices.length) {
						var cameraId = devices[0].id;
						console.log(devices);
						// .. use this to start scanning.
						mod.payout.scanner.start();
						mod.vars.scan_btn.hide();
					}
					}).catch(err => {
					// handle err
					});
				},
				start: function() {
					mod.objs.code_scanner = new Html5QrcodeScanner(
					    "reader", 
					    { 
					        fps: 10,
					        qrbox: { width: 350, height: 350 },
					        experimentalFeatures: {
					            useBarCodeDetectorIfSupported: true
					        },					        
					        rememberLastUsedCamera: true
					    });
					mod.objs.code_scanner.render(mod.payout.scanner.success);
				},
				success: function(decodedText, decodedResult) {

					if (mod.vars.scanned_data == null) {
						mod.vars.scanned_data = decodedResult;
						mod.vars.claim_form.find('[name="unique-key"]').val(decodedText);
						mod.vars.claim_form.submit();
					}
				},
				reset: function() {
					mod.vars.claim_form.find('[name="unique-key"]').val('');
					setTimeout(function(){
						mod.vars.scanned_data = null;
					}, 3000);
				}
			},
			inputKey: {
				init: function() {
					mod.vars.claim_form.on('submit', mod.payout.inputKey.submit);
					mod.vars.claim_form.find('.btn-view').on('click', mod.payout.inputKey.view);
				},
				submit: function(e) {
					e.preventDefault();
					let modeInput = mod.vars.claim_form.find('[name="mode"]');
					mod.vars.utils.validate(mod.vars.claim_form).then(function(res) {
						if (mod.vars.ajaxdone == true) {
							mod.vars.ajaxdone = false;
							mod.vars.utils.ajaxcall('POST', '/bet/ticket/claim', mod.vars.claim_form.serialize()).then(function(res) {
								console.log(res);
								if (res.success) {
									let modeType = modeInput.val().toUpperCase();
									mod.vars.utils.prompt('success', res.message, modeType+' payout');
									if (res.data.ticket) {
										mod.objs.ticket_data = res.data;
										let title = ''+modeType+' Stub for Bet#'+mod.objs.ticket_data.bet_info.unique_key;
										let modconfig = {
											target: 'print-ticket-modal',
											title: title,
											form: mod.objs.ticket_data.ticket,
										};

										mod.vars.utils.modal.prep(modconfig);
										mod.vars.utils.modal.show(modconfig);
										mod.ticket.print.init();
										modeInput.val('claim');
										//mod.payout.scanner.reset();
									}
								}
								mod.vars.ajaxdone = true;
							}, function(err){
								console.log(err);
								if (err.status == 406) {
									mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
									mod.payout.scanner.reset();
								}
								mod.vars.ajaxdone = true;
							});							
						}
					});

				},
				view: function(e) {
					e.preventDefault();
					//Reset input hidden for viewing mode
					mod.vars.claim_form.find('[name="mode"]').val('view');
					mod.vars.claim_form.submit();

				}
			}
		},
		ticket: {
			modal: {
				init: function() {
					mod.ticket.modal.when.hidden();
					if (!mod.objs.ticket_modal_obj) {
						mod.objs.ticket_modal_obj = new bootstrap.Modal(document.getElementById('print-ticket-modal'), {
						  keyboard: false,
						  backdrop: 'static'
						});
						
					}
				},
				prep: function(data) {
					mod.vars.ticket_modal_el.find('[data-bs-dismiss="modal"]').on('click', mod.ticket.modal.hide);
					mod.ticket.modal.reset();
					mod.ticket.modal.init();
					mod.vars.ticket_modal_el.find('.modal-title').html(data.title);
					mod.vars.ticket_modal_el.find('.modal-body').html(data.ticket);
				},
				reset: function() {
					mod.vars.ticket_modal_el.find('.modal-title').html('');
					mod.vars.ticket_modal_el.find('.modal-body').html('<p>Modal body text goes here.</p>');
				},
				show: function() {
					mod.objs.ticket_modal_obj.show();
				},
				hide: function() {
					mod.objs.ticket_modal_obj.hide();
					mod.vars.bet_input.val('');
				},
				when: {
					shown: function() {

					},
					hidden: function() {
						document.getElementById('print-ticket-modal').addEventListener('hidden.bs.modal', function(event){
							console.log(event);
							console.log('Modal closed');
						});
					}
				}
			},
			print: {
				init: function() {
					if (mod.vars.print_bind == false) {
						$(document).find('.print-ticket').on('click', mod.ticket.print.start);	
						mod.vars.print_bind = true;
					}
				},
				start: function() {
					// var prtContent = document.getElementById('printable');
					var WinPrint =
					window.open('/print/view/'+mod.objs.ticket_data.bet_info.unique_key,'','left=0,top=0');
					WinPrint.onload = function() {
						WinPrint.focus();
						WinPrint.print();
						WinPrint.onafterprint = function(){
						   console.log("Printing completed...");
						   WinPrint.close();
						}

						setTimeout(function(){
							WinPrint.close();
						}, 700);	
					};
					// mod.vars.utils.ajaxcall('POST', '/print/ticket', {"unique-key":mod.objs.ticket_data.bet_info.unique_key}).then(function(res) {

					// 	if (res.success) {
					// 		mod.vars.utils.prompt('success', res.message, 'Print Status');
					// 		mod.vars.loaded_fight_table.ajax.reload();
					// 	}

					// }, function(err){
					// 	console.log(err);
					// 	if (err.status == 406) {
					// 		mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
					// 		mod.payout.scanner.reset();
					// 	}
					// });
					// let title = 'Ticket for Bet#'+mod.objs.ticket_data.bet_info.unique_key;
					// let printable = $(document).find('#printable');
					// mod.vars.utils.print(printable, title, function() {
					// 	mod.vars.loaded_fight_table.ajax.reload();						
					// });					
				}
			}
		}
	};
	mod.init();
	return mod;
})();
