"use strict";
(function(){
	var mod = {
		vars: {
			date_input: $(document).find('[name="fight-date"]'),
			fight_table_list: $(document).find('#fight-table-list'),
			print_holder: $(document).find('#print-holder'),
			utils: null,
			date_set: null,
			dt_btn: {
				file: $(document).find('.btn-export-report'),
				print: $(document).find('.btn-print-report'),
			},
			active_fkey: null,
			ishistory: null
		},
		objs: {
			ftl_obj: null
		},
		init: function() {
			mod.vars.utils = window.bsutils;
			mod.vars.ishistory = typeof ishistory != 'undefined' ? ishistory : false;
			mod.list.init();
			mod.buttons.init();
		},
		list: {
			init: function() {
				mod.list.date.init();
			},
			date: {
				init: function() {
					mod.vars.date_input.on('change', mod.list.date.onchange);
					mod.list.table.refresh();
					// mod.list.date.nowdate();
				},
				nowdate: function() {
					let now = new Date();
					let date = now.toLocaleDateString("en-US",{year:"numeric",month:"2-digit",day:"2-digit"});
					let parseDate = date.split('/');
					let formattedDate = parseDate[2]+'-'+parseDate[0]+'-'+parseDate[1];
					mod.vars.date_set = formattedDate;
					mod.vars.date_input.val(formattedDate);
					mod.list.table.refresh();
				},
				onchange: function() {
					console.log($(this).val());
					mod.vars.date_set = $(this).val();
					mod.list.table.refresh();
				},
				latest: function() {
					console.log(mod.vars.date_set);
					return mod.vars.date_set;
				}
			},
			table: {
				refresh: function() {
					if (mod.objs.ftl_obj == null) {
						mod.list.table.load();
					} else {
						console.log(mod.objs.ftl_obj.ajax);
						mod.objs.ftl_obj.ajax.reload();
					}
				},
				load: function() {
					let server = window.location.origin + (mod.vars.ishistory == true ? '/datatable/fight-list/history' : '/datatable/fight-list');
					console.log(server);
					mod.objs.ftl_obj = mod.vars.fight_table_list.DataTable({
						// searching: false,
						destroy: true,
						processing: true,
	        			serverSide: true,
	        			ajax: {
	                        url: server,
	                        data: function(d) {
	                        	d.ishistory = mod.vars.ishistory;
	                        	d._token = mod.vars.utils.vars.csrf;
	                        	d.date = mod.list.date.latest();
	                        },
	                        type: 'POST',
	                    },
	        			order: [[0, 'desc']],
	                    columnDefs: [{ "targets": "_all", "defaultContent": "" }],
	                    columns: [
	                    	{ "data":"fight_number", "title":"Fight#", "orderable":true, "searchable":true },
	                    	{ 
	                    		"data":"unique_key", "title":"Key", "orderable":true, "searchable":true,
	                    		render: function(data, type, row) {
	                    			return '<a href="/bet/place/meron/'+data+'">'+data+'</a>';
	                    		}
	                    	},
	                    	{ "data":"bet_start", "title":"Start", "orderable":true, "searchable":true },
	                    	{ "data":"bet_end", "title":"End", "orderable":true, "searchable":true },
	                    	{ 
	                    		"data":"bet_status", "title":"Bet Status", "orderable":true, "searchable":true,
	                    		render: function(data, type, row) {
	                    			let modTxt = !mod.vars.utils.toTitleCase(data) ? '' : mod.vars.utils.toTitleCase(data);
	                    			return modTxt;
	                    		}
	                    	},
	                    	{ "data":"meron", "title":"Meron", "orderable":true, "searchable":true },
	                    	{ "data":"meron_odds", "title":"Meron Payout", "orderable":true, "searchable":true },
	                    	{ "data":"wala", "title":"Wala", "orderable":true, "searchable":true },
	                    	{ "data":"wala_odds", "title":"Wala Payout", "orderable":true, "searchable":true },
	                    	{ "data":"total_bets", "title":"Total Bets", "orderable":true, "searchable":true },
	                    	{ 
	                    		"data":"status", "title":"Status", "orderable":true, "searchable":true,
	                    		render: function(data, type, row) {
									let modTxt = !mod.vars.utils.toTitleCase(data) ? '' : mod.vars.utils.toTitleCase(data);
									let colors = [];
									colors['active'] = 'badge-success';
									colors['closed'] = 'badge-danger';
									return '<span class="badge '+colors[data]+'">'+modTxt+'</span>';
	                    		}
	                    	},
	                    	{ 
	                    		"data":"result", "title":"Result", "orderable":true, "searchable":true,
	                    		render: function(data, type, row) {
									let modTxt = !mod.vars.utils.toTitleCase(data) ? '' : mod.vars.utils.toTitleCase(data);
									let colors = [];
									colors['meron'] = 'success';
									colors['wala'] = 'danger';
									let finalColor = 'info';
									finalColor = typeof colors[data] != 'undefined' ? colors[data] : finalColor;
									if (current_role == 'cashier' || mod.vars.ishistory == true) {
										return '<span class="badge badge-'+finalColor+'">'+modTxt+'</span>';	
									} else {
										return '<button class="btn btn-'+finalColor+' btn-change-result" data-fkey="'+row.unique_key+'">'+modTxt+'</button>';	
									}
									
	                    		}
	                    	},
	                    ],
	                    initComplete: function(distable, data){
	                    	console.log(mod.objs.ftl_obj);
	                    	console.log(mod.objs.ftl_obj.data());
	                    	console.log(mod.objs.ftl_obj.ajax.params());
	                    },
	                    drawCallback: function() {
	                    	mod.buttons.setResult.init();
	                    }
					});	
				}
			},
		},
		buttons: {
			init: function() {
				mod.vars.dt_btn.file.on('click', mod.buttons.export.file.request);
				mod.vars.dt_btn.print.on('click', mod.buttons.print);
			},
			export: {
				file: {
					request: function(e) {
						e.preventDefault();
						if (mod.objs.ftl_obj.data().length > 0) {
							let dtparams = mod.objs.ftl_obj.ajax.params();
							dtparams.export_type = $(this).data('type');
							console.log(dtparams);
							mod.vars.utils.ajaxcall('POST', '/downloads/fights/request', dtparams).then(function(res){
								if (res.success) {
									if (res.data.new_window) {
										window.open(res.data.new_window);
									}
								}
							}, function(err) {
								console.log(err);
							});					
						} else {
							mod.vars.utils.prompt('error', 'Sorry! There is nothing to export on this current table.', 'Export table to PDF');
						}
					},
					download: function(response) {
						var blob = new Blob([response], {type: 'application/pdf'})
						var url = URL.createObjectURL(blob);
						location.assign(url);
					} 
				}
			},
			print: function(e) {
				e.preventDefault();
				if (mod.objs.ftl_obj.data().length > 0) {
					mod.vars.print_holder.html('');
					let dtparams = mod.objs.ftl_obj.ajax.params();
					mod.vars.utils.ajaxcall('POST', '/renders/fight/list/table', dtparams).then(function(res){
						if (res.success) {
							if (res.data.printable) {
								mod.vars.print_holder.append(res.data.printable);
								let printable = $(document).find('#printable-table');
								mod.vars.utils.print(printable, res.data.title, function() {
									mod.vars.print_holder.html('');
								});
							}
						}
					}, function(err) {
						console.log(err);
						mod.vars.print_holder.html('');
					});					
				} else {
					mod.vars.utils.prompt('error', 'Sorry! There is nothing to print on this current table.', 'Print table');
				}
			},
			setResult: {
				init: function() {
					$(document).find('.btn-change-result').each(function(){
						if ($(this).hasClass('event_bind') == false) {
							$(this).on('click', mod.buttons.setResult.requestForm);
							$(this).addClass('event_bind');
						}
					});

				},
				requestForm: function(e) {
					e.preventDefault();
					mod.vars.active_fkey = $(this).data('fkey');
					console.log($(this).data('fkey'));
					
					mod.vars.utils.ajaxcall('POST', '/fights/forms/results', {"fight-key": mod.vars.active_fkey}).then(function(res){
						if (res.success) {
							if (res.data.form) {
								let modconfig = {
									target: 'fight-modal',
									title: 'Set Fight Result',
									form: res.data.form,
								};

								mod.vars.utils.modal.prep(modconfig);
								mod.vars.utils.modal.show(modconfig);
								$(document).find('#set-fight-result').on('submit', mod.buttons.setResult.setResult);

							}
						}
					}, function(err) {
						console.log(err);
					});
				},
				setResult: function(e) {
					e.preventDefault();
					let activeForm = $(this);
					mod.vars.utils.validate(activeForm).then(function(res) {
						mod.vars.utils.ajaxcall('POST', '/fights/overwrite/result', activeForm.serialize()).then(function(res) {
							console.log(res);
							if (res.success) {
								mod.vars.utils.prompt('success', res.message, 'Fight Update');
								mod.list.table.refresh();
							}
						}, function(err){
							console.log(err);
							if (err.status == 406) {
								mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
							}
						});
					});
				},
			}

		}
	};
	mod.init();
	return mod;
})();
