"use strict";
(function(){
	var mod = {
		vars: {
			date_input: $(document).find('[name="income-date"]'),
			income_table_list: $(document).find('#income-table-list'),
			print_holder: $(document).find('#print-holder'),
			form: null,
			utils: null,
			dt_btn: {
				file: $(document).find('.btn-export-report'),
				print: $(document).find('.btn-print-report'),
			},
			ishistory: null,
		},
		objs: {
			itl_obj: null
		},
		init: function() {
			mod.vars.utils = window.bsutils;
			mod.vars.ishistory = typeof ishistory != 'undefined' ? ishistory : false;
			mod.list.init();
			mod.buttons.init();
		},
		list: {
			init: function() {
				mod.list.date.init();
			},
			date: {
				init: function() {
					mod.vars.date_input.on('change', mod.list.date.onchange);
					mod.list.table.refresh();
					// mod.list.date.nowdate();
				},
				nowdate: function() {
					let now = new Date('2022-10-03');
					let date = now.toLocaleDateString("en-US",{year:"numeric",month:"2-digit",day:"2-digit"});
					let parseDate = date.split('/');
					let formattedDate = parseDate[2]+'-'+parseDate[0]+'-'+parseDate[1];
					mod.vars.date_set = formattedDate;
					mod.vars.date_input.val(formattedDate);
					mod.list.table.refresh();
				},
				onchange: function() {
					console.log($(this).val());
					mod.vars.date_set = $(this).val();
					mod.list.table.refresh();
				},
				latest: function() {
					console.log(mod.vars.date_set);
					return mod.vars.date_set;
				}
			},
			table: {
				refresh: function() {
					if (mod.objs.btl_obj == null) {
						mod.list.table.load();
					} else {
						console.log(mod.objs.btl_obj.ajax);
						mod.objs.btl_obj.ajax.reload();
					}
				},
				load: function() {
					let server = window.location.origin + (mod.vars.ishistory == true ? '/datatable/income-list/history' : '/datatable/income-list');
					console.log(server);
					mod.objs.btl_obj = mod.vars.income_table_list.DataTable({
						// searching: false,
						paging: true,
						destroy: true,
						processing: true,
	        			serverSide: true,
	        			ajax: {
	                        url: server,
	                        data: function(d) {
	                        	d.ishistory = mod.vars.ishistory;
	                        	d._token = mod.vars.utils.vars.csrf;
	                        	d.date = mod.list.date.latest();
	                        },
	                        type: 'POST',
	                    },
	                    lengthMenu: [
	                    	[10, 25, 50, -1],
	                    	[10, 25, 50, 'All']
	                    ],
	        			order: [[0, 'desc']],
	                    columnDefs: [{ "targets": "_all", "defaultContent": "" }],
	                    columns: [
	                    	{ "data":"fight_number", "title":"Fight #", "orderable":true, "searchable":true },
	                    	{ "data":"bet_start", "title":"Date", "orderable":true, "searchable":true },
	                    	{ "data":"result", "title":"Result", "orderable":true, "searchable":true },
	                    	{ 
	                    		"data":"meron", "title":"Meron Bets", "orderable":true, "searchable":true,
	                    		render: function(data, type, row) {
									return mod.vars.utils.money_format(data, 2);
	                    		}
	                    	},
	                    	{ 
	                    		"data":"wala", "title":"Wala Bets", "orderable":true, "searchable":true,
	                    		render: function(data, type, row) {
									return mod.vars.utils.money_format(data, 2);
	                    		}
	                    	},
	                    	{ 
	                    		"data":"total_bets", "title":"Total Bets", "orderable":true, "searchable":true,
	                    		render: function(data, type, row) {
									return mod.vars.utils.money_format(data, 2);
	                    		}
	                    	},
	                    	{ 
	                    		"data":"income", "title":"Income (Total Bets x .05)", "orderable":true, "searchable":true,
	                    		render: function(data, type, row) {
									return mod.vars.utils.money_format(data, 2);
	                    		}
	                    	},
	                    	
	                    ],
	                    initComplete: function(distable, data){
	                    },
	                    drawCallback: function() {
	                    	
	                    }
					});	
				}
			},
		},
		buttons: {
			init: function() {
				mod.vars.dt_btn.print.on('click', mod.buttons.print);
			},
			print: function(e) {
				e.preventDefault();
				if (mod.objs.btl_obj.data().length > 0) {
					mod.vars.print_holder.html('');
					let dtparams = mod.objs.btl_obj.ajax.params();
					mod.vars.utils.ajaxcall('POST', '/renders/income/list/table', dtparams).then(function(res){
						if (res.success) {
							if (res.data.printable) {
								mod.vars.print_holder.append(res.data.printable);
								let printable = $(document).find('#printable-table');
								mod.vars.utils.print(printable, res.data.title, function() {
									mod.vars.print_holder.html('');
								});
							}
						}
					}, function(err) {
						console.log(err);
						mod.vars.print_holder.html('');
					});					
				} else {
					mod.vars.utils.prompt('error', 'Sorry! There is nothing to print on this current table.', 'Print table');
				}
			}
		}		
	};
	mod.init();
	return mod;
})();
