"use strict";
(function(){
	var mod = {
		vars: {
			form: null,
			action: '',
			utils: null,
            reset_form: null,
		},
		objs: {},
		init: function() {
			console.log(window);
			console.log($);
			mod.vars.form = $('#login-form');
            mod.vars.reset_form = $('#reset-form');
			mod.vars.utils = window.bsutils;
			mod.submit();
            mod.submit_reset();
		},
		submit: function() {
			//Validate here
			mod.vars.form.submit(function(e){
				e.preventDefault();
				mod.vars.utils.validate(mod.vars.form).then(function(res) {
					console.log(res);
					if (res) {
						console.log('submitting form');
						mod.vars.utils.ajaxcall('POST', '/oauth/login', mod.vars.form.serialize()).then(function(res) {
							console.log(res);
							if (res.success) {
								mod.vars.utils.prompt('success', res.message, 'Login');
								if (res.data.redirect) {
									mod.vars.utils.redirect(res.data.redirect);
								}
							}
						}, function(err){
							console.log(err);
							if (err.status == 406) {
								mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                                if (err.responseJSON.data != '') {
                                    mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                                }
							}
						});

					}
				});
			});
		},
        submit_reset: function() {
			//Validate here
			mod.vars.reset_form.submit(function(e){
				e.preventDefault();
				mod.vars.utils.validate(mod.vars.reset_form).then(function(res) {
					if (res) {
						mod.vars.utils.ajaxcall('POST', '/oauth/password_reset', mod.vars.reset_form.serialize()).then(function(res) {
							console.log(res);
							if (res.success) {
								mod.vars.utils.prompt('success', res.message, 'Reset Password');
								if (res.data.redirect) {
									mod.vars.utils.redirect(res.data.redirect);
								}
							}
						}, function(err){
							console.log(err);
							if (err.status == 406) {
								mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                                if (err.responseJSON.data != '') {
                                    mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                                }
							}
						});

					}
				});
			});
		}
	};
	mod.init();
	return mod;
})();
