"use strict";
(function(){
	var mod = {
		vars: {
			user_table_list: $(document).find('#user-table-list'),
			form: null,
			utils: null
		},
		objs: {
			btl_obj: null,
		},
		init: function() {
			mod.vars.utils = window.bsutils;
			mod.list.init();
			mod.form.init_btn();
		},
		list: {
			init: function() {
				mod.list.table.load();
			},
			table: {
				refresh: function() {
					if (mod.objs.btl_obj == null) {
						mod.list.table.load();
					} else {
						console.log(mod.objs.btl_obj.ajax);
						mod.objs.btl_obj.ajax.reload();
					}
				},
				load: function() {
					let server = window.location.origin+'/datatable/user-list';
					console.log(server);
					mod.objs.btl_obj = mod.vars.user_table_list.DataTable({
						// searching: false,
						paging: true,
						destroy: true,
						processing: true,
	        			serverSide: true,
	        			ajax: {
	                        url: server,
	                        data: function(d) {
	                        	d._token = mod.vars.utils.vars.csrf;
	                        },
	                        type: 'POST',
	                    },
	        			order: [[0, 'desc']],
	                    columnDefs: [{ "targets": "_all", "defaultContent": "" }],
	                    columns: [
	                    	{ "data":"id", "title":"ID", "orderable":true, "searchable":true },
	                    	{ "data":"username", "title":"Username", "orderable":true, "searchable":true },
	                    	{ "data":"role", "title":"Role", "orderable":true, "searchable":true },
	                    	{ "data":"last_login", "title":"Last Login", "orderable":true, "searchable":true },
	                    	{ 
	                    		"data":"actions", "title":"Actions", "orderable":false, "searchable":false,
	                    		render: function(data, type, row) {

	                    			let delete_btn = row.username == 'superadmin' ? '' : '&nbsp;<button type="button" class="ml btn btn-sm btn-danger delete-user" data-uid="'+data+'"><i class="fa fa-trash"></i></button>';
									return '<button type="button" class="btn btn-sm btn-success call-user-form" data-uid="'+data+'">Edit</button>'+delete_btn;
	                    		}
	                    	}
	                    ],
	                    initComplete: function(distable, data){
	                    },
	                    drawCallback: function() {
	                    	mod.form.init_btn();
	                    	// mod.ticket.view.init();
	                    	// console.log(mod.objs.btl_obj);
	                    	// console.log(mod.objs.btl_obj.data());
	                    	// console.log(mod.objs.btl_obj.ajax.params())
	                    }
					});	
				}
			},
		},
		form: {
			init_btn: function() {
				$(document).find('.call-user-form').each(function(){
					let dis = $(this);
					if (dis.hasClass('hasEvent')==false) {
						dis.on('click', mod.form.call);		
						dis.addClass('hasEvent');
						// dis.find('#role').on('change', mod.form.toggleCashier);
						// dis.find('#role').trigger('change');
					}
				});

				$(document).find('.delete-user').each(function(){
					let dis = $(this);
					if (dis.hasClass('hasEvent')==false) {
						dis.on('click', mod.form.delete);		
						dis.addClass('hasEvent');
					}
				});
				
				mod.form.load();
			},
			delete: function(e) {
				e.preventDefault();
				let dis = $(this);
				let uid = typeof dis.data('uid') != 'undefined' ? dis.data('uid') : 0 ;
				if (uid > 0) {
					if (confirm("Are you sure you want to delete this user?") == true) {
						mod.vars.utils.ajaxcall('POST', '/users/delete', {"uid":uid}).then(function(res) {
							console.log(res);
							if (res.success) {
								mod.vars.utils.prompt('success', res.message, 'User Removal');
								mod.objs.btl_obj.ajax.reload();
							}
						}, function(err){
							console.log(err);
							if (err.status == 406) {
								mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
							}
						});
					}
				}
			},
			call: function(e) {
				e.preventDefault();
				let dis = $(this);
				let uid = typeof dis.data('uid') != 'undefined' ? dis.data('uid') : 0 ;
				mod.vars.utils.ajaxcall('GET', '/users/form/'+uid, {}).then(function(res) {
					if (res.success) {
						console.log(res);
						let mconfig = {
							target: 'user-modal',
							title: uid > 0 ? 'Edit User' : 'Create User',
							form: res.data.user_form
						};
						mod.vars.utils.modal.prep(mconfig);
						mod.vars.utils.modal.show();
						mod.form.cashier.init();
					}
				}, function(err){
					console.log(err);
					if (err.status == 406) {
						mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
					}
				});
			},
			load: function() {
				$(document).find('.save-user').each(function(){
					let dis = $(this);
					if (dis.hasClass('hasEvent')==false) {
						dis.on('click', mod.form.submit);
						dis.addClass('hasEvent');
					}
				});
			},
			submit: function(e) {
				e.preventDefault();
				let dis = $(this);
				let form = dis.closest('.modal').find('form');
				let dataset = form.serialize();
				mod.vars.utils.ajaxcall('POST', '/users/process/save', dataset).then(function(res){
					if (res.success) {
						mod.vars.utils.prompt('success', res.message, 'User');
						mod.vars.utils.modal.hide();
						mod.objs.btl_obj.ajax.reload();
					}
				}, function(err){
					console.log(err);
					if (err.status == 406) {
						mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
					}
				});
			},
			cashier: {
				init: function() {
					if ($(document).find('.modal input[type="hidden"]').length > 0) {
						$(document).find('.modal #password, .modal #confirm-password').val('');	
						setTimeout(function(){
							$(document).find('.modal #password, .modal #confirm-password').val('');	
						}, 800);
					} else {
						$(document).find('.modal input[type="text"]').val('');	
						setTimeout(function(){
							$(document).find('.modal #password, .modal #confirm-password, .modal input[type="text"]').val('');
						}, 800);
					}
					
					$(document).find('.modal #role').on('change', mod.form.cashier.toggle);
					$(document).find('.modal #role').trigger('change');
				},
				toggle: function(e) {
					let dis = $(this);
					console.log(dis.val());
					if (dis.val() == 'cashier') {
						dis.closest('form').find('.cashier-type').show();
					} else {
						dis.closest('form').find('.cashier-type').hide();
						dis.closest('form').find('.cashier-type input[type="radio"]').prop('checked', false);
					}
				}
			}
		}
	};
	mod.init();
	return mod;
})();
