"use strict";
(function(){
	var mod = {
		vars: {
			interval: null,
			form: $(document).find('#update-interval'),
			utils: null
		},
		objs: {
			time_interval: null,
		},
		init: function() {
			mod.vars.utils = window.bsutils;
			mod.vars.interval = interval;
			mod.time.countDown();
			mod.vars.form.on('submit', mod.backup.update);

		},
		time: {
    		countDown: function() {
    			let intervalCookie = mod.vars.utils.cookie.get('interval');
				var timer2 = !intervalCookie ? mod.vars.interval+":00" : intervalCookie;
				mod.objs.time_interval = setInterval(function() {
				  var timer = timer2.split(':');
				  //by parsing integer, I avoid all extra string processing
				  var minutes = parseInt(timer[0], 10);
				  var seconds = parseInt(timer[1], 10);
				  --seconds;
				  minutes = (seconds < 0) ? --minutes : minutes;
				  if (minutes < 0) clearInterval(mod.objs.time_interval);
				  seconds = (seconds < 0) ? 59 : seconds;
				  seconds = (seconds < 10) ? '0' + seconds : seconds;
				  //minutes = (minutes < 10) ?  minutes : minutes;
				  $('.countdown').html(minutes + ':' + seconds);
				  timer2 = minutes + ':' + seconds;
				  mod.vars.utils.cookie.set('interval', timer2, 10);

				  if (timer2 == '0:00') {
				  	clearInterval(mod.objs.time_interval);
				  	$('.countdown').html('Backup Starting...');
				  	mod.vars.utils.cookie.erase('interval');
				  	mod.backup.trigger();
				  }

				}, 1000);
    		}
		},
		backup: {
			trigger: function() {
				mod.vars.utils.ajaxcall('GET', '/backup/trigger', {}).then(function(res) {
					console.log(res);
					if (res.success) {
						mod.vars.utils.prompt('success', res.message, 'Backup Status');
						mod.vars.utils.cookie.erase('interval');
						window.location.reload();
					}
				}, function(err){
					console.log(err);
					if (err.status == 406) {
						mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
						mod.vars.bet_input.val('');
					}
				});
			},
			update: function(e) {
				e.preventDefault();
				mod.vars.utils.validate(mod.vars.form).then(function(res) {
					if (res) {
						mod.vars.utils.ajaxcall('POST', '/backup/update', mod.vars.form.serialize()).then(function(res) {
							if (res.success) {
								mod.vars.utils.prompt('success', res.message, 'Backup Status');
								clearInterval(mod.objs.time_interval);
				  				$('.countdown').html('Resetting countdown...');
				  				mod.vars.utils.cookie.erase('interval');
				  				setTimeout(function(){
				  					window.location.reload();
				  				}, 1000);
							}
						}, function(err){
							console.log(err);
							if (err.status == 406) {
								mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
							}
						});
						
					}
				});
			}
		}
	};
	mod.init();
	return mod;
})();
