"use strict";
(function(){
	var mod = {
		vars: {
			form: null,
			action: '',
			utils: null,
			cashier_table: $(document).find('#cashier-table-list')
		},
		objs: {},
		init: function() {
			console.log(window);
			console.log($);
			mod.vars.utils = window.bsutils;
			mod.table.load();
			mod.form.init_btn();
		},
		table: {
			load: function() {
				let server = window.location.origin+'/cashier/list';
					console.log(server);
					mod.vars.cashier_table = mod.vars.cashier_table.DataTable({
						searching: true,
						processing: true,
	        			serverSide: true,
	        			ajax: {
	                        url: server,
	                        data: {_token:mod.vars.utils.vars.csrf},
	                        type: 'POST',
	                    },
	        			order: [[3, 'desc']],
	                    columnDefs: [{ "targets": "_all", "defaultContent": "" }],
	                    columns: [
	                    	{ "data" : "email",        "title" : "Email",           "orderable": true, "searchable": true },
	                    	{ "data" : "name",        "title" : "Name",           "orderable": true, "searchable": false },
	                    	{ "data" : "last_login",        "title" : "Last Login",           "orderable": true, "searchable": false },
	                    	{ "data" : "verified_at",        "title" : "Verified At",           "orderable": true, "searchable": false },
	                    	{
	                    		"data":"actions", "title":"Actions", "orderable":false, "searchable":false,
	                    		render: function(data, type, row) {
	                    			let delete_btn = row.role == 'admin' ? '' : '&nbsp;<button type="button" class="ml btn btn-sm btn-danger delete-user" data-uid="'+row.id+'"><i class="fa fa-trash"></i></button>';
									return '<button type="button" class="btn btn-sm btn-success call-user-form" data-uid="'+row.id+'">Edit</button>'+delete_btn;
	                    		}
	                    	}
	                    ],
	                    initComplete: function(distable, data){
	                    },
	                    drawCallback: function() {
	                    	mod.form.init_btn();
	                    }
					});
			}
		},
		form: {
			init_btn: function() {
				$(document).find('.call-user-form').each(function(){
					let dis = $(this);
					if (dis.hasClass('hasEvent')==false) {
						dis.on('click', mod.form.call);
						dis.addClass('hasEvent');
						// dis.find('#role').on('change', mod.form.toggleCashier);
						// dis.find('#role').trigger('change');
					}
				});

				$(document).find('.delete-user').each(function(){
					let dis = $(this);
					if (dis.hasClass('hasEvent')==false) {
						dis.on('click', mod.form.delete);
						dis.addClass('hasEvent');
					}
				});

				mod.form.load();
			},
			delete: function(e) {
				e.preventDefault();
				let dis = $(this);
				let uid = typeof dis.data('uid') != 'undefined' ? dis.data('uid') : 0 ;
				if (uid > 0) {
					if (confirm("Are you sure you want to delete this user?") == true) {
						mod.vars.utils.ajaxcall('POST', '/cashier/delete', {"user_id":uid}).then(function(res) {
							console.log(res);
							if (res.success) {
								mod.vars.utils.prompt('success', res.message, 'User Removal');
								mod.vars.cashier_table.ajax.reload();
							}
						}, function(err){
							console.log(err);
							if (err.status == 406) {
								mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                                mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
							}
						});
					}
				}
			},
			call: function(e) {
				e.preventDefault();
				let dis = $(this);
				let uid = typeof dis.data('uid') != 'undefined' ? dis.data('uid') : 0 ;
				mod.vars.utils.ajaxcall('GET', '/user/form/'+uid, {'type':'cashier'}).then(function(res) {
					if (res.success) {
						console.log(res);
						let mconfig = {
							target: 'user-modal',
							title: uid > 0 ? 'Edit Cashier' : 'Create Cashier',
							form: res.data.user_form
						};
						mod.vars.utils.modal.prep(mconfig);
						mod.vars.utils.modal.show();
						mod.form.cashier.init();
					}
				}, function(err){
					console.log(err);
					if (err.status == 406) {
						mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                        mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
					}
				});
			},
			load: function() {
				$(document).find('.save-user').each(function(){
					let dis = $(this);
					if (dis.hasClass('hasEvent')==false) {
						dis.on('click', mod.form.submit);
						dis.addClass('hasEvent');
					}
				});
			},
			submit: function(e) {
				e.preventDefault();
				let dis = $(this);
				let form = dis.closest('.modal').find('form');
				let dataset = form.serialize();
                let mode = form.find('[name="mode"]').val() == 'edit' ? 'update' : 'create';
				mod.vars.utils.ajaxcall('POST', '/cashier/'+mode, dataset).then(function(res){
					if (res.success) {
						mod.vars.utils.prompt('success', res.message, 'User');
						mod.vars.utils.modal.hide();
						mod.vars.cashier_table.ajax.reload();
					}
				}, function(err){
					console.log(err);
					if (err.status == 406) {
						mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                        mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
					}
				});
			},
			cashier: {
				init: function() {
					if ($(document).find('.modal input[type="hidden"]').length > 0) {
						$(document).find('.modal #password, .modal #confirm-password').val('');
						setTimeout(function(){
							$(document).find('.modal #password, .modal #confirm-password').val('');
						}, 800);
					} else {
						$(document).find('.modal input[type="text"]').val('');
						setTimeout(function(){
							$(document).find('.modal #password, .modal #confirm-password, .modal input[type="text"]').val('');
						}, 800);
					}

					$(document).find('.modal #role').on('change', mod.form.cashier.toggle);
					$(document).find('.modal #role').trigger('change');
				},
				toggle: function(e) {
					let dis = $(this);
					console.log(dis.val());
					if (dis.val() == 'cashier') {
						dis.closest('form').find('.cashier-type').show();
					} else {
						dis.closest('form').find('.cashier-type').hide();
						dis.closest('form').find('.cashier-type input[type="radio"]').prop('checked', false);
					}
				}
			}
		}
	};
	mod.init();
	return mod;
})();
