"use strict";
(function(){
	var mod = {
		vars: {
			form: null,
			action: '',
			utils: null,
            claims_table: $(document).find('#claims-table-list')
		},
		objs: {},
		init: function() {
			mod.vars.utils = window.bsutils;
            mod.table.load();
		},
        table: {
			load: function() {
				let server = window.location.origin+'/claims/list';
					console.log(server);
					mod.vars.claims_table = mod.vars.claims_table.DataTable({
						searching: true,
						processing: true,
	        			serverSide: true,
	        			ajax: {
	                        url: server,
	                        data: {_token:mod.vars.utils.vars.csrf},
	                        type: 'POST',
	                    },
	        			order: [[0, 'desc']],
	                    columnDefs: [{ "targets": "_all", "defaultContent": "" }],
	                    columns: [
	                    	{ "data" : "name",        "title" : "Name",           "orderable": true, "searchable": true },
	                    	{ "data" : "promo",        "title" : "Promo",           "orderable": true, "searchable": true },
	                    	{ "data" : "cashier",        "title" : "Cashier",           "orderable": true, "searchable": false },
	                    	{ "data" : "points",        "title" : "Points Spent",           "orderable": true, "searchable": false },
                            { "data" : "date",        "title" : "Date",           "orderable": true, "searchable": false },
	                    ],
	                    initComplete: function(distable, data){
	                    },
	                    drawCallback: function() {
	                    }
					});
			}
		},
	};
	mod.init();
	return mod;
})();
