"use strict";
(function(){
	var mod = {
		vars: {
			fight_table: $(document).find('#fight-table'),
			loaded_fight_table: null,
			create_btn: $(document).find('.create-fight'),
			remove_btn: $(document).find('.remove-fight'),
			reset_btn: $(document).find('.reset-fights'),
			form: null,
			utils: null,
			result_form: null,
			status_form: null,
			remove_form: null,
			fight_key: null,
			display_type: null,
			hold_btn: $(document).find('.hold-betting')
		},
		objs: {
			monitor_loop: null,
			fight_monitor: null
		},
		init: function() {
			console.log(window);
			console.log($);
			mod.vars.utils = window.bsutils;
			mod.vars.fight_key = typeof fkey != 'undefined' ? fkey : null;
			mod.vars.display_type = typeof display_type != 'undefined' ? display_type : null;
			mod.vars.create_btn.on('click', mod.create);
			mod.vars.remove_btn.on('click', mod.removeFight);
			mod.vars.reset_btn.on('click', mod.resetFights);
			

			mod.vars.result_form = $('#set-fight-result');
			mod.vars.result_form.on('submit', mod.setResult);
			mod.vars.status_form = $('#set-fight-status');
			mod.vars.status_form.on('submit', mod.setStatus);

			mod.monitor.init();
			mod.hold.init();
			if (window.location.href.indexOf('fights/active/full') > -1) {
				console.log('No table monitor');
			} else {
				mod.table.load();
				mod.table.monitor();				
			}
			mod.carousel.init();
		},
		monitor: {
			init: function() {

				if (mod.objs.monitor_loop != null) {
					clearInterval(mod.objs.monitor_loop);
				}

				mod.objs.monitor_loop = setInterval(function(){
					mod.monitor.refresh();
				}, 3000);
			},
			refresh: function() {
				if (mod.vars.fight_key != null && mod.vars.display_type != null) {
					mod.vars.utils.ajaxcall('GET', '/renders/fight/monitor/'+mod.vars.fight_key+'/'+mod.vars.display_type, {}).then(function(res){
						if (res.success) {
							if (res.data.next_fight == true) {
								window.location.reload();
							}
							// $(document).find('.fmc-main').html('');
							$(document).find('.fmc-main .full-monitor').replaceWith(res.data.monitor);
							setTimeout(function(){
								mod.hold.init();
							},100);

						}
					}, function(err) {
						console.log(err);
					});					
				}
			},
		},
		hold: {
			init: function() {
				$(document).find('.hold-betting').on('click', mod.hold.start);
			},
			start: function(e) {
				e.preventDefault();
				let dis = $(this);
				let side = dis.data('side');
				let mode = typeof dis.data('mode') != 'undefined' ? dis.data('mode') : 'hold';
				let params = {};
				params['fight-key'] = mod.vars.fight_key;
				params['hold-mode'] = mode;
				mod.vars.utils.ajaxcall('POST', '/fights/hold/'+side, params).then(function(res) {
					console.log(res);
					if (res.success) {
						mod.vars.utils.prompt('success', res.message, 'Hold status');
						mod.monitor.refresh();
						mod.monitor.init();
					}
				}, function(err){
					console.log(err);
					if (err.status == 406) {
						mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
					}
				});				


			}
		},
		create: function(e) {
			e.preventDefault();
			let resetVal = $(this).data('reset');

			mod.vars.utils.ajaxcall('POST', '/fights/create', {reset:resetVal}).then(function(res) {
				console.log(res);
				if (res.success) {
					mod.vars.utils.prompt('success', res.message, 'Fight Creation');
					if (res.data.redirect) {
						mod.vars.utils.redirect(res.data.redirect);
					}
				}
			}, function(err){
				console.log(err);
				if (err.status == 406) {
					mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
				}
			});
		},
		removeFight: function(e) {
			e.preventDefault();
			mod.vars.utils.ajaxcall('POST', '/fights/remove', {remove:true}).then(function(res) {
				console.log(res);
				if (res.success) {
					mod.vars.utils.prompt('success', res.message, 'Fight Removal');
					if (res.data.redirect) {
						mod.vars.utils.redirect(res.data.redirect);
					}
				}
			}, function(err){
				console.log(err);
				if (err.status == 406) {
					mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
				}
			});
		},
		resetFights: function(e) {
			e.preventDefault();
			if (confirm("Are you sure you want to reset the order of fights? This will close any active fight and will require you to create a new one.") == true) {

				let modconfig = {
					target: 'fight-modal',
					title: 'Reset System In Progress',
					form: '<div class="alert alert-danger">DANGER!</div><p>Do not refresh this page. Reset process is in progress. Thank you.</p>',
				};

				mod.vars.utils.modal.prep(modconfig);
				mod.vars.utils.modal.show(modconfig);

				mod.vars.utils.ajaxcall('POST', '/fights/reset', {reset:true}).then(function(res) {
					console.log(res);
					if (res.success) {
						mod.vars.utils.prompt('success', res.message, 'Reset Status');
						if (res.data.redirect) {
							mod.vars.utils.redirect(res.data.redirect);
							mod.vars.utils.modal.hide();
						}
					}
				}, function(err){
					console.log(err);
					if (err.status == 406) {
						mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
						mod.vars.utils.modal.hide();
					}
				});
			}
		},
		setResult: function(e) {
			e.preventDefault();
			mod.vars.utils.validate(mod.vars.result_form).then(function(res) {
				mod.vars.utils.ajaxcall('POST', '/fights/set/result', mod.vars.result_form.serialize()).then(function(res) {
					console.log(res);
					if (res.success) {
						mod.vars.utils.prompt('success', res.message, 'Fight Creation');
						if (res.data.redirect) {
							mod.vars.utils.redirect(res.data.redirect);
						}
					}
				}, function(err){
					console.log(err);
					if (err.status == 406) {
						mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
					}
				});
			});
		},
		setStatus: function(e) {
			e.preventDefault();
			mod.vars.utils.validate(mod.vars.status_form).then(function(res) {
				mod.vars.utils.ajaxcall('POST', '/fights/set/status', mod.vars.status_form.serialize()).then(function(res) {
					console.log(res);
					if (res.success) {
						mod.vars.utils.prompt('success', res.message, 'Fight Creation');
						if (res.data.redirect) {
							mod.vars.utils.redirect(res.data.redirect);
						}
					}
				}, function(err){
					console.log(err);
					if (err.status == 406) {
						mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
					}
				});
			});
		},
		table: {
			load: function() {
				$(document).ready(function(){
					if (mod.vars.fight_key != null) {
						let server = window.location.origin+'/datatable/fight/'+mod.vars.fight_key;
						console.log(server);
						mod.vars.loaded_fight_table = mod.vars.fight_table.DataTable({
							searching: false,
							processing: true,
		        			serverSide: true,
		        			ajax: {
		                        url: server,
		                        data: {_token:mod.vars.utils.vars.csrf},
		                        type: 'POST',
		                    },
		        			order: [[0, 'desc']],
		                    columnDefs: [{ "targets": "_all", "defaultContent": "" }],
		                    columns: [
		                    	{ "data" : "id",        "title" : "Fight #",           "orderable": true, "searchable": false },
		                    	{ "data" : "formatted_meron",        "title" : "Meron",           "orderable": true, "searchable": false },
		                    	{ "data" : "formatted_wala",        "title" : "Wala",           "orderable": true, "searchable": false },
		                    	{ "data" : "formatted_status",        "title" : "Status",           "orderable": true, "searchable": false },
		                    	{ "data" : "formatted_result",        "title" : "Result",           "orderable": true, "searchable": false },
		                    ],
		                    initComplete: function(distable, data){
		                    }
						});						
					}
				});
			},
			monitor: function() {

				if (mod.objs.fight_monitor != null) {
					clearInterval(mod.objs.fight_monitor);
				}

	            mod.objs.fight_monitor = setInterval(function(){
	                if (mod.vars.loaded_fight_table != null) {
	                	mod.vars.loaded_fight_table.ajax.reload();
	                }
	            }, 3000);				
			}
		},
		carousel: {
			init: function() {
				if ($(document).find('.fight-carousel').length > 0) {
					mod.carousel.start();
				}
			},
			start: function() {
				$(document).find('.fight-carousel').slick({
				  	slidesToShow: 10,
				  	slidesToScroll: 1,
				  	autoplay: true,
				  	autoplaySpeed: 2500,
				});
			}
		}
	};
	mod.init();
	return mod;
})();
