"use strict";
(function(){
	var mod = {
		vars: {
			profile_form: null,
            profile_display: null,
            avatar_form: null,
			utils: null,
            input_file: null
		},
		objs: {
            user: null
		},
		init: function() {
			mod.vars.utils = window.bsutils;
            mod.vars.profile_form = $('#profile-form');
            mod.vars.profile_display = $('#profile-display');
            mod.vars.avatar_form = $('#avatar');
            mod.vars.input_file = $('#inputFile');
            mod.profile.fetch();
            mod.profile.btns.init();
            mod.vars.profile_form.on('submit', mod.profile.form.submit);
            mod.profile.avatar.init();
		},
        profile: {
            fetch: function() {
                mod.vars.utils.ajaxcall('GET', '/user/current', {}).then(function(res) {
                    if(typeof res.profile != 'undefined') {
                        mod.objs.user = res;
                    }
                }, function(err){
                    console.log(err);
                    if (err.status == 406) {
                        mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                        if (err.responseJSON.data.length > 0 || err.responseJSON.data != '') {
                            mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                        }
                    }
                });
            },
            form: {
                submit: function(e) {
                    e.preventDefault();
                    mod.vars.utils.validate(mod.vars.profile_form).then(function(res) {
                        if (res) {
                            mod.vars.utils.ajaxcall('POST', '/user/profile/update', mod.vars.profile_form.serialize()).then(function(res) {
                                console.log(res);
                                if (res.success) {
                                    window.location.reload();
                                }
                            }, function(err){
                                console.log(err);
                                if (err.status == 406) {
                                    mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                                    if (err.responseJSON.data.length > 0 || err.responseJSON.data != '') {
                                        mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                                    }
                                }
                            });

                        }
                    });
                },
            },
            btns: {
                init: function() {
                    $(document).find('#edit').on('click', mod.profile.btns.edit);
                    $(document).find('#cancel').on('click', mod.profile.btns.cancel);
                },
                edit: function(e) {
                    e.preventDefault();
                    $(this).removeClass('show').addClass('hide');
                    $('#cancel').removeClass('hide').addClass('show');
                    mod.vars.profile_display.hide();
                    mod.vars.profile_form.show();
                },
                cancel: function(e) {
                    e.preventDefault();
                    $(this).removeClass('show').addClass('hide');
                    $('#edit').removeClass('hide').addClass('show');
                    mod.vars.profile_display.show();
                    mod.vars.profile_form.hide();
                }
            },
            avatar: {
                init: function() {
                    $('#avatar-picker').on('click', mod.profile.avatar.pick_image);
                    mod.vars.input_file.on('change', mod.profile.avatar.upload);
                    // mod.vars.avatar_form.click(mod.profile.avatar.pick_image);
                },
                pick_image: function(e) {
                    e.preventDefault();
                    mod.vars.input_file.get(0).click();
                },
                upload: function(e) {
                    e.preventDefault();
                    console.log('Start upload');
                    let formEl = $('#avatar')[0];
                    console.log(formEl)
                    let formData = new FormData(formEl);
                    mod.vars.utils.ajaxupload('/user/avatar', formData).then(function(res) {
                        console.log(res);
                        if (res.success) {
                            window.location.reload();
                        }
                    }, function(err){
                        console.log(err);
                        if (err.status == 406) {
                            mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                            if (err.responseJSON.data.length > 0 || err.responseJSON.data != '') {
                                mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                            }
                        }
                    });

                }
            }
        }
	};
	mod.init();
	return mod;
})();
