"use strict";
(function(){
	var mod = {
		vars: {
			form: null,
			action: '',
			utils: null,
            services_table: $(document).find('#services-table-list')
		},
		objs: {},
		init: function() {
			mod.vars.utils = window.bsutils;
            mod.table.load();
            mod.form.init_btn();
		},
        table: {
			load: function() {
				let server = window.location.origin+'/service/list';
					console.log(server);
					mod.vars.services_table = mod.vars.services_table.DataTable({
						searching: true,
						processing: true,
	        			serverSide: true,
	        			ajax: {
	                        url: server,
	                        data: {_token:mod.vars.utils.vars.csrf},
	                        type: 'POST',
	                    },
	        			order: [[0, 'desc']],
	                    columnDefs: [{ "targets": "_all", "defaultContent": "" }],
	                    columns: [
	                    	{ "data" : "name",        "title" : "Name",           "orderable": true, "searchable": true },
	                    	{ "data" : "cost",        "title" : "Cost",           "orderable": true, "searchable": true },
	                    	{ "data" : "points",        "title" : "Points",           "orderable": true, "searchable": false },
	                    	{ "data" : "availability",        "title" : "Availability",           "orderable": true, "searchable": false },
                            { "data" : "added_by",        "title" : "Added By",           "orderable": true, "searchable": false },
	                    	{
	                    		"data":"actions", "title":"Actions", "orderable":false, "searchable":false,
	                    		render: function(data, type, row) {
	                    			let delete_btn = row.role == 'admin' ? '' : '&nbsp;<button type="button" class="ml btn btn-sm btn-danger delete-service" data-sid="'+row.id+'"><i class="fa fa-trash"></i></button>';
									return '<button type="button" class="btn btn-sm btn-success call-service-form" data-sid="'+row.id+'">Edit</button>'+delete_btn;
	                    		}
	                    	}
	                    ],
	                    initComplete: function(distable, data){
	                    },
	                    drawCallback: function() {
	                    	mod.form.init_btn();
	                    }
					});
			}
		},
        form: {
            init_btn: function() {
                $(document).find('.call-service-form').each(function(){
					let dis = $(this);
					if (dis.hasClass('hasEvent')==false) {
						dis.on('click', mod.form.call);
						dis.addClass('hasEvent');
					}
				});

				$(document).find('.delete-service').each(function(){
					let dis = $(this);
					if (dis.hasClass('hasEvent')==false) {
						dis.on('click', mod.form.delete);
						dis.addClass('hasEvent');
					}
				});
            },
			call: function(e) {
				e.preventDefault();
				let dis = $(this);
				let sid = typeof dis.data('sid') != 'undefined' ? dis.data('sid') : 0 ;
				mod.vars.utils.ajaxcall('GET', '/service/form/'+sid, {}).then(function(res) {
					if (res.success) {
						console.log(res);
						let mconfig = {
							target: 'user-modal',
							title: sid > 0 ? 'Edit Service' : 'Create Service',
							form: res.data.user_form
						};
						mod.vars.utils.modal.prep(mconfig);
						mod.vars.utils.modal.show();
						mod.form.load();
					}
				}, function(err){
					console.log(err);
					if (err.status == 406) {
						mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                        mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
					}
				});
			},
            delete: function(e) {
				e.preventDefault();
				let dis = $(this);
				let sid = typeof dis.data('sid') != 'undefined' ? dis.data('sid') : 0 ;
				if (sid > 0) {
					if (confirm("Are you sure you want to delete this service?") == true) {
						mod.vars.utils.ajaxcall('POST', '/service/delete', {"service_id":sid}).then(function(res) {
							console.log(res);
							if (res.success) {
								mod.vars.utils.prompt('success', res.message, 'Service Removal');
								mod.vars.services_table.ajax.reload();
							}
						}, function(err){
							console.log(err);
							if (err.status == 406) {
								mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                                mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
							}
						});
					}
				}
			},
            load: function() {
				$(document).find('.save-user').each(function(){
					let dis = $(this);
					if (dis.hasClass('hasEvent')==false) {
						dis.on('click', mod.form.submit);
						dis.addClass('hasEvent');
					}
				});
			},
			submit: function(e) {
				e.preventDefault();
				let dis = $(this);
				let form = dis.closest('.modal').find('form');
				let dataset = form.serialize();
                let mode = form.find('[name="mode"]').val() == 'edit' ? 'update' : 'create';
				mod.vars.utils.ajaxcall('POST', '/service/'+mode, dataset).then(function(res){
					if (res.success) {
						mod.vars.utils.prompt('success', res.message, 'User');
						mod.vars.utils.modal.hide();
						mod.vars.services_table.ajax.reload();
					}
				}, function(err){
					console.log(err);
					if (err.status == 406) {
						mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                        mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
					}
				});
			},
        }
	};
	mod.init();
	return mod;
})();
