"use strict";
(function(){
	var mod = {
		vars: {
			form: null,
			action: '',
			utils: null,
			transaction_table: $(document).find('#transaction-table-list'),
            customer_table: null,
            scan_ajax: false,
            total: {
                cost: 0,
                points: 0
            }
		},
		objs: {
            html5scanner: null,
            user: null
        },
		init: function() {
			console.log(window);
			console.log($);
			mod.vars.utils = window.bsutils;
            if (typeof user == 'object') {
                mod.objs.user = user;
                console.log(mod.objs.user.role);
            }
			mod.table.load();
            mod.form.transaction.init();
            mod.form.search.init_btn();
            mod.form.qr.init();
            mod.form.mobile.init();
		},
		table: {
			load: function() {
				let server = window.location.origin+'/transaction/list';
                let dynamicCols = [
                    { "data" : "service",        "title" : "Service",           "orderable": true, "searchable": true },
                    { "data" : "customer_name",        "title" : "Customer",           "orderable": true, "searchable": false },
                    { "data" : "points_earned",        "title" : "Points Earned",           "orderable": true, "searchable": false },
                    { "data" : "cashier_name",        "title" : "Cashier",           "orderable": true, "searchable": false },
                    { "data" : "created_at",        "title" : "Service Done",           "orderable": true, "searchable": false },
                    {
                        "data":"actions", "title":"Actions", "orderable":false, "searchable":false,
                        render: function(data, type, row) {
                            let delete_btn = '&nbsp;<button type="button" class="ml btn btn-sm btn-danger delete-user" data-txnid="'+row.id+'"><i class="fa fa-trash"></i></button>';
                            return '<button type="button" class="btn btn-sm btn-success call-txn-form" data-uid="'+row.customer_user_id+'" data-txnid="'+row.id+'">Edit</button>'+delete_btn;
                        }
                    }
                ];

                if (mod.objs.user != null && mod.objs.user.role == 'customer') {
                    dynamicCols = [
                        { "data" : "service",        "title" : "Service",           "orderable": true, "searchable": true },
                        { "data" : "customer_name",        "title" : "Customer",           "orderable": true, "searchable": false },
                        { "data" : "points_earned",        "title" : "Points Earned",           "orderable": true, "searchable": false },
                        { "data" : "cashier_name",        "title" : "Cashier",           "orderable": true, "searchable": false },
                        { "data" : "created_at",        "title" : "Service Done",           "orderable": true, "searchable": false },
                    ];
                    console.log(dynamicCols);
                }

					mod.vars.transaction_table = mod.vars.transaction_table.DataTable({
						searching: true,
						processing: true,
	        			serverSide: true,
	        			ajax: {
	                        url: server,
	                        data: {_token:mod.vars.utils.vars.csrf},
	                        type: 'POST',
	                    },
	        			order: [[4, 'desc']],
	                    columnDefs: [{ "targets": "_all", "defaultContent": "" }],
	                    columns: dynamicCols,
	                    initComplete: function(distable, data){
	                    },
	                    drawCallback: function() {
                            if (mod.objs.user != null && mod.objs.user.role == 'customer') {
                            } else {
                                mod.form.search.init_btn();
                                mod.form.transaction.init();
                            }
	                    }
					});
			},
            customer: {
                load: function() {
                    mod.vars.customer_table = $(document).find('#customer-table-list');
                    let server = window.location.origin+'/customer/list';

                        mod.vars.customer_table = mod.vars.customer_table.DataTable({
                            searching: true,
                            processing: true,
                            serverSide: true,
                            ajax: {
                                url: server,
                                data: {_token:mod.vars.utils.vars.csrf},
                                type: 'POST',
                            },
                            order: [[1, 'desc']],
                            columnDefs: [{ "targets": "_all", "defaultContent": "" }],
                            columns: [
                                { "data" : "email",        "title" : "Email",           "orderable": true, "searchable": true },
                                { "data" : "name",        "title" : "Name",           "orderable": true, "searchable": true },
                                {
                                    "data":"actions", "title":"Actions", "orderable":false, "searchable":false,
                                    render: function(data, type, row) {
                                        let rowstr = JSON.stringify(row);
                                        return '<button type="button" class="btn btn-sm btn-success select-user" data-uid="'+row.id+'" data-name="'+row.name+'"><i class="fa fa-check"></i></button>';
                                    }
                                }
                            ],
                            initComplete: function(distable, data){
                            },
                            drawCallback: function() {
                                mod.form.search.init_btn();
                            }
                        });
                }
            }
		},
		form: {
			transaction: {
				init: function() {
                    $(document).find('.call-txn-form').each(function(){
                        let dis = $(this);
                        if (dis.hasClass('hasEvent')==false) {
                            dis.on('click', mod.form.transaction.call);
                            dis.addClass('hasEvent');
                        }
                    });
                    $(document).find('.delete-user').each(function(){
                        let dis = $(this);
                        if (dis.hasClass('hasEvent')==false) {
                            dis.on('click', mod.form.transaction.delete);
                            dis.addClass('hasEvent');
                        }
                    });
				},
                call: function(e) {
                    e.preventDefault();
                    let dis = $(this);
                    let uid = dis.data('uid');
                    let txnid = dis.data('txnid') == undefined ? 0 : dis.data('txnid');
                    if (uid == undefined) {
                        mod.vars.utils.prompt('error', 'Search and select a customer by clicking the check button within the row.', 'Oops!');
                        return false;
                    }

                    mod.form.transaction.ajaxcall('form', uid, txnid).then(function(res){
                        if (res) {
                            console.log($(document).find('.services-checkbox').length);
                            // $(document).find('.services-checkbox').on('change', mod.form.transaction.services_checkbox);
                            const service_checkbox = document.getElementsByClassName('services-checkbox');
                            for (var i = 0; i < service_checkbox.length; i++) {
                                service_checkbox[i].addEventListener('change', mod.form.transaction.services_checkbox, false);
                            }

                        }
                    });
                },
                ajaxcall: function(formtype,uid, txnid) {
                    return new Promise(function(resolve, reject) {
                        mod.vars.utils.modal.hide();
                        mod.vars.utils.ajaxcall('GET', '/transaction/'+formtype+'/'+uid+'/'+txnid, {}).then(function(res) {
                            if (res.success) {
                                console.log(res);
                                let mconfig = {
                                    target: 'user-modal',
                                    title: 'Add Transaction',
                                    form: res.data.user_form
                                };
                                mod.vars.utils.modal.prep(mconfig);
                                mod.vars.utils.modal.show();
                                mod.form.transaction.load();
                                setTimeout(function(){
                                    mod.vars.scan_ajax = false;
                                }, 1500);
                            }
                            resolve(true);
                        }, function(err){
                            console.log(err);
                            if (err.status == 406) {
                                mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                                mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                            }
                        });
                    });
                },
                load: function() {
                    $(document).find('.save-user').each(function(){
                        let dis = $(this);
                        if (dis.hasClass('hasEvent')==false) {
                            dis.on('click', mod.form.transaction.submit);
                            dis.addClass('hasEvent');
                        }
                    });
                },
                submit: function(e) {
                    e.preventDefault();
                    let dis = $(this);
                    let form = dis.closest('.modal').find('form');
                    let txn_input = form.find('input[name="txn_id"]');
                    let mode = txn_input.length > 0 ? 'update' : 'create';
                    let dataset = form.serialize();
                    mod.vars.utils.ajaxcall('POST', '/transaction/'+mode, dataset).then(function(res){
                        if (res.success) {
                            mod.vars.utils.prompt('success', res.message, 'User');
                            mod.vars.utils.modal.hide();
                            mod.vars.transaction_table.ajax.reload();
                        }
                    }, function(err){
                        console.log(err);
                        if (err.status == 406) {
                            mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                            mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                        }
                    });
                },
                delete: function(e) {
                    e.preventDefault();
                    let dis = $(this);
                    let txn_id = typeof dis.data('txnid') != 'undefined' ? dis.data('txnid') : 0 ;
                    if (txn_id > 0) {
                        if (confirm("Are you sure you want to delete this user?") == true) {
                            mod.vars.utils.ajaxcall('POST', '/transaction/delete', {"txn_id":txn_id}).then(function(res) {
                                console.log(res);
                                if (res.success) {
                                    mod.vars.utils.prompt('success', res.message, 'User Removal');
                                    mod.vars.transaction_table.ajax.reload();
                                }
                            }, function(err){
                                console.log(err);
                                if (err.status == 406) {
                                    mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                                    mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                                }
                            });
                        }
                    }
                },
                services_checkbox: function(e) {
                    let dis = $(this);
                    // if (dis.is(':checked')) {
                    if (e.currentTarget.checked) {
                        mod.vars.total.cost = mod.vars.total.cost+parseInt(dis.data('cost'));
                        mod.vars.total.points = mod.vars.total.points+parseInt(dis.data('points'));
                    } else {
                        mod.vars.total.cost = mod.vars.total.cost-parseInt(dis.data('cost'));
                        mod.vars.total.points = mod.vars.total.points-parseInt(dis.data('points'));
                    }
                    console.log(mod.vars.total);
                    $(document).find('#transaction-form [name="amount"]').val(mod.vars.total.cost);
                    $(document).find('#transaction-form [name="points"]').val(mod.vars.total.points);
                }
			},
            search: {
                init: function() {
                    setTimeout(function(){
                        mod.table.customer.load();
                    }, 500);
                },
                init_btn: function() {
                    $(document).find('.call-user-form').each(function(){
                        let dis = $(this);
                        if (dis.hasClass('hasEvent')==false) {
                            dis.on('click', mod.form.search.call);
                            dis.addClass('hasEvent');
                            // dis.find('#role').on('change', mod.form.toggleCashier);
                            // dis.find('#role').trigger('change');
                        }
                    });
                    $(document).find('.select-user').each(function(){
                        let dis = $(this);
                        if (dis.hasClass('hasEvent')==false) {
                            dis.on('click', mod.form.search.select_btn);
                            dis.addClass('hasEvent');
                        }
                    });
                },
                call: function(e) {
                    e.preventDefault();
                    let dis = $(this);
                    mod.vars.utils.ajaxcall('GET', '/transaction/user/search/', {}).then(function(res) {
                        if (res.success) {
                            console.log(res);
                            let mconfig = {
                                target: 'user-modal',
                                title: 'Search Customer',
                                form: res.data.user_form,
                                hide_btns: true
                            };
                            mod.vars.utils.modal.prep(mconfig);
                            mod.vars.utils.modal.show();
                            mod.form.search.init();
                            mod.form.transaction.init();
                        }
                    }, function(err){
                        console.log(err);
                        if (err.status == 406) {
                            mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                            mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                        }
                    });
                },
                select_btn: function(e) {
                    e.preventDefault();
                    let dis = $(this);
                    console.log('click');
                    let customer_id = dis.data('uid');
                    console.log(customer_id);
                    let name = dis.data('name');
                    console.log(name);
                    let form = $(document).find('#user-form');
                    form.find('.call-txn-form').attr('data-uid', customer_id);
                    form.find('#customer_name').val(name);
                    setTimeout(function(){
                        $('.modal-open .modal').scrollTop(-1000);
                    }, 500);
                }
            },
            qr: {
                init: function() {
                    $(document).find('.scan-form').on('click', mod.form.qr.call);
                },
                call: function(e) {
                    e.preventDefault();
                    let dis = $(this);
                    mod.vars.utils.ajaxcall('GET', '/transaction/qrpreview/', {}).then(function(res) {
                        if (res.success) {
                            console.log(res);
                            let mconfig = {
                                target: 'user-modal',
                                title: 'QR Preview',
                                form: res.data.user_form,
                                hide_btns: true
                            };
                            mod.vars.utils.modal.prep(mconfig);
                            mod.vars.utils.modal.show();
                            if (mod.objs.html5scanner != null) {
                                mod.objs.html5scanner.clear();
                            }
                            setTimeout(function(){
                                mod.form.qr.scanner.init();
                            }, 500);

                        }
                    }, function(err){
                        console.log(err);
                        if (err.status == 406) {
                            mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                            mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                        }
                    });
                },
                scanner:  {
                    init: function() {
                        mod.objs.html5scanner = new Html5QrcodeScanner(
                            "preview", { fps: 10, qrbox: 250, rememberLastUsedCamera: false });
                        mod.objs.html5scanner.render(mod.form.qr.scanner.onSuccess, mod.form.qr.scanner.onFailure);
                    },
                    onSuccess: function(decodedText, decodedResult) {
                        if (decodedText != '' && mod.vars.scan_ajax == false) {
                            console.log(`Scan result: ${decodedText}`, decodedResult);
                            mod.vars.scan_ajax = true;
                            mod.form.transaction.ajaxcall('scan', decodedText, 0).then(function(res){
                                mod.objs.html5scanner.clear();
                            });

                        }
                    },
                    onFailure: function(error) {
                        console.warn(`Code scan error = ${error}`);
                    }
                }
            },
            mobile: {
                init: function() {
                    $(document).find('.mobile-form').on('click', mod.form.mobile.call);
                },
                init_btn: function() {
                    $(document).find('#mobile-form').closest('.modal').find('.save-user').on('click', mod.form.mobile.submit);
                },
                call: function() {
                    let dis = $(this);
                    mod.vars.utils.ajaxcall('GET', '/transaction/mobile/form/', {}).then(function(res) {
                        if (res.success) {
                            console.log(res);
                            let mconfig = {
                                target: 'user-modal',
                                title: 'Search Mobile',
                                form: res.data.user_form,
                            };
                            mod.vars.utils.modal.prep(mconfig);
                            mod.vars.utils.modal.show();
                            mod.form.mobile.init_btn();
                        }
                    }, function(err){
                        console.log(err);
                        if (err.status == 406) {
                            mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                            mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                        }
                    });
                },
                submit: function(e) {
                    e.preventDefault();
                    let dis = $(this);
                    let form = dis.closest('.modal').find('form');
                    let dataset = form.serialize();
                    mod.vars.utils.ajaxcall('POST', '/transaction/mobile/verify/', dataset).then(function(res) {
                        if (res.success) {
                            console.log(res);
                            let mconfig = {
                                target: 'user-modal',
                                title: 'Add Transaction',
                                form: res.data.user_form
                            };
                            mod.vars.utils.modal.prep(mconfig);
                            mod.vars.utils.modal.show();
                            mod.form.transaction.load();
                            setTimeout(function(){
                                mod.vars.scan_ajax = false;
                            }, 1500);
                        }
                    }, function(err){
                        console.log(err);
                        if (err.status == 406) {
                            mod.vars.utils.prompt('error', err.responseJSON.message, 'Oops!');
                            mod.vars.utils.prompt('error', err.responseJSON.data, 'Oops!');
                        }
                    });
                }
            }
		}
	};
	mod.init();
	return mod;
})();
