@if (isset($notifications) && !empty($notifications))
<li class="nav-item dropdown no-arrow mx-1">
    <a class="nav-link dropdown-toggle" href="#" id="alertsDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
        <i class="fas fa-bell fa-fw"></i>
        <!-- Counter - Alerts -->
        <span class="badge badge-danger badge-counter">{{count($notifications)}}</span>
    </a>
    <!-- Dropdown - Alerts -->
    <div class="dropdown-list dropdown-menu dropdown-menu-right shadow animated--grow-in" aria-labelledby="alertsDropdown">
        <h6 class="dropdown-header">
            Notification Center
        </h6>
        @foreach ($notifications as $nkey => $nitem )
            @if ($nitem->viewed == 0 && $nkey < 3)
                <a class="dropdown-item d-flex align-items-center notif-item" href="#" data-nid="{{$nitem->id}}">
                    <div class="mr-3">
                        <div class="icon-circle bg-primary">
                            <i class="fas fa-file-alt text-white"></i>
                        </div>
                    </div>
                    <div>
                        <div class="small text-gray-500">{{\App\Helpers\Utilities::formatDateTime('M d, Y', $nitem->promo->created_at)}}</div>
                        <span class="font-weight-bold">{{$nitem->promo->promo_name}} (
                            {{
                            \App\Helpers\Utilities::formatDateTime('M d, Y', $nitem->promo->start) .'-'.
                            \App\Helpers\Utilities::formatDateTime('M d, Y', $nitem->promo->end)
                            }}
                            )</span>
                    </div>
                </a>
            @endif
        @endforeach
        <a class="dropdown-item text-center small text-gray-500 read-all" href="#">Mark all as Read</a>
    </div>
</li>
@section('modulescript')
    @parent
    @include('commons.modal', ['modal_id'=>'notif-modal', 'save_btn_classes' => 'save-user'])
    <script type="text/javascript" src="{{ mix('/js/components/notifications.js') }}?ver{{env('APP_ASSETS')}}"></script>
@endsection
@endif
