<div class="row">
    <div class="col-xl-4 col-md-6 mb-4">
        <div class="card shadow mb-4">
            <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                <h6 class="m-0 font-weight-bold text-primary">QR Code</h6>
            </div>
            <div class="card-body">
                <div class="text-center">{{ \App\Helpers\UserHelper::generateQrCode($user->profile->qrstring, 300)  }}</div>
            </div>
        </div>
    </div>
    <div class="col-xl-4 col-md-6 mb-4">
        <div class="card shadow mb-4">
            <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                <h6 class="m-0 font-weight-bold text-primary">Transaction</h6>
            </div>
            <div class="card-body">
                <h6>Last Transaction</h6>
                <?php $last_transaction = \App\Helpers\UserHelper::getLastTransaction($user->id); ?>
                @if(is_null($last_transaction))
                    You do not have any transaction yet. Visit us at Mezzanine Level, UniMart Greenhills, San Juan City.
                @else
                <div class="table-responsive">
                    <table class="table table-bordered" id="last-transaction-table-list">
                        <thead>
                            <tr>
                                <th>Service</th>
                                <th>Date</th>
                                <th>Points</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td>{{$last_transaction->service}}</td>
                                <td>{{$last_transaction->created_at}}</td>
                                <td>{{number_format($last_transaction->points)}}</td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                @endif
                <h6 class="mt-3">Current Points</h6>
                <?php $points = \App\Helpers\UserHelper::getTotalPoints($user->id); ?>
                @if($points > 0)
                    <button class="btn btn-block btn-success btn-lg">You now have {{$points}} points!</button>
                @else
                <button class="btn btn-block btn-dark btn-lg">You do not have points yet.</button>
                @endif
            </div>
        </div>
    </div>
    <div class="col-xl-4 col-md-6 mb-4">
        <div class="card shadow mb-4">
            <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                <h6 class="m-0 font-weight-bold text-primary">Accouncements</h6>
            </div>
            <div class="card-body">
                <img src="{{ mix('/img/ernesto-by-barberboy-logo.png') }}" width="100%" alt-text="Ernest by Barberboy">
            </div>
        </div>
    </div>
</div>
