@extends('authenticated')

@section('title', 'Cashier')

@section('content')
            <!-- Main Content -->
            <div id="content">

                @include('commons.topbar')

                                <!-- Begin Page Content -->
                <div class="container-fluid">
                    <div class="row">
                        <div class="col-lg-8">
                            <h1 class="h3 mb-2 text-gray-800">Cashier</h1>
                            <p class="mb-4">Check list or create and update for cashiers.</p>
                        </div>
                        <div class="col-lg-4">
                            <div class="text-right">
                                @if($user->role == 'admin')
                                <button type="button" class="btn btn-md btn-primary call-user-form">Create Cashier</button>
                                @endif
                            </div>
                        </div>
                    </div>
                    <div id="cashier-table-container">
                        <div class="table-responsive">
                            <table class="table table-bordered" id="cashier-table-list">
                                <thead>
                                    <tr>
                                        <th>Email</th>
                                        <th>Name</th>
                                        <th>Last Login</th>
                                        <th>Verified at</th>
                                        <th>Actions</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr>
                                        <td colspan="5">Fetching data...</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>


                </div>
                <!-- /.container-fluid -->

            </div>
            <!-- End of Main Content -->
            @include('commons.modal', ['modal_id'=>'user-modal', 'save_btn_classes' => 'save-user'])

@endsection
@section('modulescript')
    @parent
    <script type="text/javascript" src="{{ mix('/js/jquery.dataTables.min.js') }}?ver{{env('APP_ASSETS')}}"></script>
    <script type="text/javascript" src="{{ mix('/js/dataTables.buttons.min.js') }}?ver{{env('APP_ASSETS')}}"></script>
    <script type="text/javascript" src="{{ mix('/js/dataTables.bootstrap4.min.js') }}?ver{{env('APP_ASSETS')}}"></script>
    <script type="text/javascript" src="{{ mix('/js/modules/cashier.js') }}?ver{{env('APP_ASSETS')}}"></script>
@endsection
