@extends('authenticated')

@section('title', 'Dashboard')

@section('content')
            <!-- Main Content -->
            <div id="content">

                @include('commons.topbar')

                <!-- Begin Page Content -->
                <div class="container-fluid">
                    <div class="d-sm-flex align-items-center justify-content-between mb-4">
                        <h1 class="h3 mb-0 text-gray-800">Quick Access</h1>
                    </div>
                    @if ($user->role != 'customer')
                        @include('components.admin-cashier-dashboard')
                    @else
                        @include('components.customer-dashboard')
                    @endif
                </div>
                <!-- /.container-fluid -->

            </div>
            <!-- End of Main Content -->
            @include('commons.modal', ['modal_id'=>'user-modal', 'save_btn_classes' => 'save-user'])

@endsection
@section('modulescript')
    @parent
    <script type="text/javascript" src="{{ mix('/js/jquery.dataTables.min.js') }}?ver{{env('APP_ASSETS')}}"></script>
    <script type="text/javascript" src="{{ mix('/js/dataTables.buttons.min.js') }}?ver{{env('APP_ASSETS')}}"></script>
    <script type="text/javascript" src="{{ mix('/js/dataTables.bootstrap4.min.js') }}?ver{{env('APP_ASSETS')}}"></script>
    <script type="text/javascript" src="{{ mix('/js/html5-qrcode-2.3.8.min.js') }}?ver{{env('APP_ASSETS')}}"></script>
    <script type="text/javascript" src="{{ mix('/js/modules/transaction.js') }}?ver{{env('APP_ASSETS')}}"></script>
    <script type="text/javascript" src="{{ mix('/js/modules/dashboard.js') }}?ver{{env('APP_ASSETS')}}"></script>
@endsection
