@extends('authenticated')

@section('title', 'Promo')

@section('content')
            <!-- Main Content -->
            <div id="content">

                @include('commons.topbar')

                                <!-- Begin Page Content -->
                <div class="container-fluid">
                    <div class="row">
                        <div class="col-lg-8">
                            <h1 class="h3 mb-2 text-gray-800">Promo</h1>
                            <p class="mb-4">Check list or create and update for Promo.</p>
                        </div>
                        <div class="col-lg-4">
                            <div class="text-right">
                                @if($user->role == 'admin')
                                <button type="button" class="btn btn-md btn-primary call-promo-form">Create Promo</button>
                                @endif
                            </div>
                        </div>
                    </div>
                    <div id="promo-table-container">
                        <div class="table-responsive">
                            <table class="table table-bordered" id="promo-table-list">
                                <thead>
                                    <tr>
                                        <th>Name</th>
                                        <th>Details</th>
                                        <th>Start</th>
                                        <th>End</th>
                                        <th>For Broadcast</th>
                                        <th>Points Required</th>
                                        <th>Actions</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr>
                                        <td colspan="7">Fetching data...</td>
                                    </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>


                </div>
                <!-- /.container-fluid -->

            </div>
            <!-- End of Main Content -->
            @include('commons.modal', ['modal_id'=>'promo-modal', 'save_btn_classes' => 'start-claim-promo'])
            @include('commons.modal', ['modal_id'=>'create-promo-modal', 'save_btn_classes' => 'save-user'])

@endsection
@section('modulescript')
    @parent
    <script type="text/javascript" src="{{ mix('/js/jquery.dataTables.min.js') }}?ver{{env('APP_ASSETS')}}"></script>
    <script type="text/javascript" src="{{ mix('/js/dataTables.buttons.min.js') }}?ver{{env('APP_ASSETS')}}"></script>
    <script type="text/javascript" src="{{ mix('/js/dataTables.bootstrap4.min.js') }}?ver{{env('APP_ASSETS')}}"></script>
    <script type="text/javascript" src="{{ mix('/js/html5-qrcode.min.js') }}?ver{{env('APP_ASSETS')}}"></script>
    <script type="text/javascript" src="{{ mix('/js/modules/promo.js') }}?ver{{env('APP_ASSETS')}}"></script>
@endsection
