<form class="transaction" id="transaction-form">
    <input type="hidden" name="customer_id" value="{{ $customer->id }}">
	@if($mode=='edit')
		<input type="hidden" name="txn_id" value="{{ $txn->id }}">
        <input type="hidden" name="service_id" value="{{ $txn->service_id }}">
        <div class="row">
            <div class="col-sm-6">
                <div class="form-group">
                    <label for="service">Service</label>
                    <input type="text" name="service" class="form-control required" readonly="" id="service" aria-describedby="service" placeholder="Haircut" value="{{ $txn->service }}">
                </div>
                <div class="form-group">
                    <label for="customer_name">Customer</label>
                    <input type="text" name="customer_name" class="form-control" readonly id="customer_name" placeholder="Customer" value="{{$fullname}}">
                </div>
                <div class="form-group">
                    <label for="amount">Amount</label>
                    <input type="number" name="amount" class="form-control" id="amount" placeholder="0" value="{{$txn->amount}}">
                </div>
                <div class="form-group">
                    <label for="points">Points</label>
                    <input type="number" name="points" class="form-control" id="points" placeholder="0" value="{{$txn->points}}">
                </div>
            </div>
            <div class="col-sm-6">
                <div class="form-group">
                    <label for="points">User QR Code</label>
                    {{$qrcode}}
                </div>
                <div class="form-group">
                    <button class="btn btn-block btn-lg btn-success">User has {{number_format($points)}} point{{number_format($points) > 2 ? 's' : ''}}</button>
                </div>
            </div>
        </div>
	@else
    <div class="row">
        <div class="col-12">
            <label>Services</label>
            @if (!is_null($services))
                <div class="row">
                    @foreach ($services as $service)
                        <div class="col-3">
                            <div class="form-group">
                                <label for="service-{{$service->id}}">
                                    <input type="checkbox" name="services[]" class="services-checkbox" id="service-{{$service->id}}" aria-describedby="service" placeholder="Haircut" data-cost="{{$service->cost}}" data-points="{{$service->points}}" value="{{$service->id}}">
                                    {{$service->name}}
                                </label>
                            </div>
                        </div>
                    @endforeach
                </div>
            @else
                <div class="alert alert-danger">You have to add services first to make a transaction. Go to <a href="{{ route('service') }}"> services</a> page to create on.</div>
            @endif
        </div>
        <div class="col-sm-6">
            <div class="form-group">
                <label for="amount">Total Amount</label>
                <input type="number" name="amount" class="form-control required" readonly id="amount" placeholder="0" value="1">
            </div>
        </div>
        <div class="col-sm-6">
            <div class="form-group">
                <label for="points">Points</label>
                <input type="number" name="points" class="form-control" readonly id="points" placeholder="0" value="1">
            </div>
        </div>
        <hr>
        <div class="col-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-4">
                            {{$qrcode}}
                        </div>
                        <div class="col-8">
                            <h5 class="card-title">{{$fullname}}</h5>
                            <p class="card-text">
                                <button class="btn btn-block btn-lg btn-success">User has {{number_format($points)}} point{{number_format($points) > 2 ? 's' : ''}}</button>
                            </p>
                        </div>
                    </div>
                </div>
              </div>
        </div>
    </div>
	@endif
</form>
