<form class="user" id="user-form">
    <input type="hidden" name="mode" value="{{ $mode }}">
	@if($mode=='edit')
		<input type="hidden" name="uid" value="{{ $user->id }}">
        <div class="row">
            <div class="col-sm-6">
                <div class="form-group">
                    <label for="email">Username</label>
                    <input type="text" name="email" readonly="readonly" class="form-control required" id="email" aria-describedby="emailHelp" placeholder="Enter Email..." value="{{ $user->email }}">
                </div>
                <div class="form-group">
                    <label for="password">Password (Leave blank if you're not updating this.)</label>
                    <input type="password" name="password" class="form-control required" id="password" placeholder="Password">
                </div>
                <div class="form-group">
                    <label for="password_confirmation">Confirm Password</label>
                    <input type="password" name="password_confirmation" class="form-control required" id="password_confirmation" placeholder="Confirm Password">
                </div>
            </div>
            <div class="col-sm-6 text-center">
                <div class="form-group">
                    <label for="role">QR Code</label>
                    {{$qrcode}}
                </div>
                <div class="form-group">
                    <button class="btn btn-block btn-lg btn-success">User has {{number_format($points)}} point{{number_format($points) > 2 ? 's' : ''}}</button>
                </div>
            </div>
            <div class="col-6">
                <div class="form-group">
                    <label for="role">First Name</label>
                    <input type="text" name="firstname" class="form-control required" id="firstname" aria-describedby="First Name" placeholder="First Name" value="{{$user->profile->firstname}}">
                </div>
                <div class="form-group">
                    <label for="role">Last Name</label>
                    <input type="text" name="lastname" class="form-control required" id="lastname" aria-describedby="Last Name" placeholder="Last Name" value="{{$user->profile->lastname}}">
                </div>
            </div>
            <div class="col-6">
                <div class="form-group">
                    <label for="role">Mobile</label>
                    <input type="text" name="mobile" class="form-control required" id="mobile" aria-describedby="Mobile" placeholder="Mobile" value="{{$user->profile->mobile}}">
                </div>
                <div class="form-group">
                    <label for="role">Address</label>
                    <input type="text" name="address" class="form-control required" id="address" aria-describedby="Address" placeholder="Address" value="{{$user->profile->address}}">
                </div>
            </div>
            <div class="col-12">
                <div class="form-group">
                    <label for="role">Role</label>
                    <select name="role" class="form-control required" id="role" value="{{ $user->role }}">
                        @foreach($roles as $role)
                            <option value="{{$role}}" {{ $user->role == $role ? 'selected="selected"' : '' }}>{{ucfirst($role)}}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="col-12">
                <div class="form-group newsletter_validation">
                    <label for="account_validation">Receive Newsletter</label>
                    <div class="row">
                        <?php $noption = ['yes','no']; ?>
                        @foreach($noption as $option)
                            <div class="col-sm-6">
                                <label for="rv-{{$option}}">
                                    @if ($user->profile->newsletter > 0)
                                        <input type="radio" name="newsletter_validation" {{$option == 'yes'  ? 'checked="checked"': ''}} id="av-{{$option}}" value="{{$option}}">
                                    {{ ucfirst($option) }}
                                    @else
                                        <input type="radio" name="newsletter_validation" {{$option == 'no'  ? 'checked="checked"': ''}} id="av-{{$option}}" value="{{$option}}">
                                    {{ ucfirst($option) }}
                                    @endif
                                </label>
                            </div>
                        @endforeach
                    </div>
                </div>
            </div>
        </div>
	@else
        <div class="row">
            <div class="col-6">
                <div class="form-group">
                    <input type="text" name="email" class="form-control required" id="email" aria-describedby="emailHelp" placeholder="Enter Email...">
                </div>
                <div class="form-group">
                    <input type="password" name="password" class="form-control required" id="password" placeholder="Password">
                </div>
                <div class="form-group">
                    <input type="password" name="password_confirmation" class="form-control required" id="password_confirmation" placeholder="Confirm Password">
                </div>
            </div>
            <div class="col-6">
                <div class="form-group">
                    <input type="text" name="firstname" class="form-control required" id="firstname" aria-describedby="First Name" placeholder="First Name">
                </div>
                <div class="form-group">
                    <input type="text" name="lastname" class="form-control required" id="lastname" aria-describedby="Last Name" placeholder="Last Name">
                </div>
                <div class="form-group">
                    <input type="text" name="mobile" class="form-control required" id="mobile" aria-describedby="Mobile" placeholder="Mobile">
                </div>
            </div>
            <div class="col-12">
                <div class="form-group">
                    <input type="text" name="address" class="form-control required" id="address" aria-describedby="Address" placeholder="Address">
                </div>
                <div class="form-group">
                    <select name="role" class="form-control required" id="role">
                        @foreach($roles as $role)
                            <option value="{{$role}}">{{ucfirst($role)}}</option>
                        @endforeach
                    </select>
                </div>
                <div class="form-group account_validation">
                    <label for="account_validation">Require Validation</label>
                    <div class="row">
                        <?php $account_validation = ['no','yes']; ?>
                        @foreach($account_validation as $actype)
                            <div class="col-sm-6">
                                <label for="av-{{$actype}}">
                                    <input type="radio" name="account_validation" {{$actype == 'no'? 'checked="checked"': ''}} id="av-{{$actype}}" value="{{$actype}}">
                                    {{ ucfirst($actype) }}
                                </label>
                            </div>
                        @endforeach
                    </div>
                </div>
                <div class="form-group newsletter_validation">
                    <label for="account_validation">Receive Newsletter</label>
                    <div class="row">
                        <?php $noption = ['yes','no']; ?>
                        @foreach($noption as $option)
                            <div class="col-sm-6">
                                <label for="rv-{{$option}}">
                                    <input type="radio" name="newsletter_validation" {{$option == 'yes'? 'checked="checked"': ''}} id="av-{{$option}}" value="{{$option}}">
                                    {{ ucfirst($option) }}
                                </label>
                            </div>
                        @endforeach
                    </div>
                </div>
            </div>
        </div>
	@endif
</form>
