<?php $__env->startSection('title', 'Dashboard'); ?>

<?php $__env->startSection('content'); ?>
            <!-- Main Content -->
            <div id="content">

                <?php echo $__env->make('commons.topbar', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>

                <!-- Begin Page Content -->
                <div class="container-fluid">
                    <div class="row mb-4">
                        <div class="col-lg-10">
                            <h1 class="h3 mb-2 text-gray-800">Profile</h1>
                        </div>
                        <div class="col-lg-2">
                            <div class="text-right">
                                <button id="edit" type="button" class="btn btn-md btn-primary mb-2">Edit</button>
                                <button id="cancel" type="button" class="btn btn-md btn-secondary mb-2 hide">Cancel</button>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-12 col-sm-12 col-md-3 col-lg-3">
                            <div class="card shadow mb-4">
                                <div class="card-body">
                                    <form id="avatar" method="POST" enctype="multipart/form-data">
                                        <?php echo csrf_field(); ?>
                                        <a href="#" id="avatar-picker"></a>
                                        <?php if(!is_null($user->profile->avatar)): ?>
                                        <img class="img-profile rounded-circle" src="<?php echo e($user->profile->avatar); ?>">
                                        <?php else: ?>
                                            <img class="img-profile rounded-circle" src="<?php echo e(mix('img/undraw_profile.svg')); ?>">
                                        <?php endif; ?>
                                            <input type="file" name="item" id="inputFile" class="form-control mt-2">
                                    </form>
                                </div>
                            </div>
                        </div>
                        <div class="col-xs-12 col-sm-12 col-md-9 col-lg-9">
                            <div class="card shadow mb-4" id="profile-display">
                                <div class="card-body">
                                    <h2><?php echo e(trim($user->profile->firstname.' '.$user->profile->lastname)); ?></h2>
                                    <div class="table-responsive">
                                        <table class="table">
                                            <tr>
                                                <td>Username/Email:</td><td><?php echo e($user->email); ?></td>
                                            </tr>
                                            <tr>
                                                <td>Mobile:</td><td><?php echo e($user->profile->mobile); ?></td>
                                            </tr>
                                            <tr>
                                                <td>Address:</td><td><?php echo e($user->profile->address); ?></td>
                                            </tr>
                                            <tr>
                                                <td>Role:</td><td><?php echo e(ucfirst($user->role)); ?></td>
                                            </tr>
                                            <tr>
                                                <td>Receive Newsletter:</td><td><?php echo e($user->profile->newsletter > 0 ? 'Yes' : 'No'); ?></td>
                                            </tr>
                                            <tr>
                                                <td>Member since:</td><td><?php echo e($user->created_at); ?></td>
                                            </tr>
                                        </table>
                                    </div>
                                </div>
                            </div>
                            <form class="card shadow mb-4 hide" id="profile-form">
                                <div class="card-body">
                                    <h2><?php echo e(trim($user->profile->firstname.' '.$user->profile->lastname)); ?></h2>
                                    <div class="table-responsive">
                                        <table class="table">
                                            <tr>
                                                <td><label for="email">Username/Email:</label></td>
                                                <td>
                                                    <div class="form-group">
                                                        <input type="text" class="form-control required" name="email" readonly placeholder="Email" value="<?php echo e($user->email); ?>">
                                                    </div>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td><label for="firstname">First Name:</label></td>
                                                <td>
                                                    <div class="form-group">
                                                        <input type="text" class="form-control required" name="firstname" placeholder="John" value="<?php echo e($user->profile->firstname); ?>">
                                                    </div>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td><label for="lastname">Last Name:</label></td>
                                                <td>
                                                    <div class="form-group">
                                                        <input type="text" class="form-control required" name="lastname" placeholder="John" value="<?php echo e($user->profile->lastname); ?>">
                                                    </div>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td><label for="mobile">Mobile:</label></td>
                                                <td>
                                                    <div class="form-group">
                                                        <input type="text" class="form-control" name="mobile" placeholder="6391712345678" value="<?php echo e($user->profile->mobile); ?>">
                                                    </div>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td><label for="address">Address:</label></td>
                                                <td>
                                                    <div class="form-group">
                                                        <textarea class="form-control" placeholder="Put your address here." name="address">
                                                            <?php echo e(trim($user->profile->address)); ?>

                                                        </textarea>
                                                    </div>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td><label for="address">Receive Newsletter:</label></td>
                                                <td>
                                                    <div class="row">
                                                        <?php $noption = ['yes','no']; ?>
                                                        <?php $__currentLoopData = $noption; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $option): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); ?>
                                                            <div class="col-sm-6">
                                                                <label for="rv-<?php echo e($option); ?>">
                                                                    <?php if($user->profile->newsletter > 0): ?>
                                                                        <input type="radio" name="newsletter_validation" <?php echo e($option == 'yes'  ? 'checked="checked"': ''); ?> id="av-<?php echo e($option); ?>" value="<?php echo e($option); ?>">
                                                                    <?php echo e(ucfirst($option)); ?>

                                                                    <?php else: ?>
                                                                        <input type="radio" name="newsletter_validation" <?php echo e($option == 'no'  ? 'checked="checked"': ''); ?> id="av-<?php echo e($option); ?>" value="<?php echo e($option); ?>">
                                                                    <?php echo e(ucfirst($option)); ?>

                                                                    <?php endif; ?>
                                                                </label>
                                                            </div>
                                                        <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); ?>
                                                    </div>
                                                </td>
                                            </tr>
                                            <tr><td colspan="2"><strong>Leave blank if you're not updating this.</strong></td></tr>
                                            <tr>
                                                <td><label for="password">Password:</label></td>
                                                <td>
                                                    <div class="form-group">
                                                        <input type="password" class="form-control" name="password" placeholder="">
                                                    </div>
                                                </td>
                                            </tr>
                                            <tr>
                                                <td><label for="password_confirmation">Confirm Password:</label></td>
                                                <td>
                                                    <div class="form-group">
                                                        <input type="password" class="form-control" name="password_confirmation" placeholder="">
                                                    </div>
                                                </td>
                                            </tr>
                                        </table>
                                    </div>
                                    <button type="submit" class="btn btn-lg btn-success btn-lg">Update</button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
                <!-- /.container-fluid -->
            </div>
            <!-- End of Main Content -->
            <?php echo $__env->make('commons.modal', ['modal_id'=>'user-modal', 'save_btn_classes' => 'save-user'], \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?>

<?php $__env->stopSection(); ?>
<?php $__env->startSection('modulescript'); ?>
    <?php echo \Illuminate\View\Factory::parentPlaceholder('modulescript'); ?>

    <script type="text/javascript" src="<?php echo e(mix('/js/modules/profile.js')); ?>"></script>
<?php $__env->stopSection(); ?>

<?php echo $__env->make('authenticated', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/u879778038/domains/jumpstartcreatives.com/public_html/ebapp/resources/views/pages/profile.blade.php ENDPATH**/ ?>