const mix = require('laravel-mix');

/*
 |--------------------------------------------------------------------------
 | Mix Asset Management
 |--------------------------------------------------------------------------
 |
 | Mix provides a clean, fluent API for defining some Webpack build steps
 | for your Laravel applications. By default, we are compiling the CSS
 | file for the application as well as bundling up all the JS files.
 |
 */

 mix.copyDirectory('resources/vendor/jquery/jquery.min.js', 'public/js').version();
 mix.copyDirectory('resources/vendor/bootstrap/js/bootstrap.min.js', 'public/js').version();

 mix.copyDirectory('resources/vendor/bootstrap/js/bootstrap.bundle.min.js', 'public/js').version();
 mix.copyDirectory('resources/vendor/bootstrap/js/bootstrap.bundle.min.js.map', 'public/js').version();
 mix.copyDirectory('resources/vendor/jquery-easing/jquery.easing.min.js', 'public/js').version();
 mix.copyDirectory('resources/vendor/bootstrap/js/bootstrap.min.js.map', 'public/js').version();
 mix.copyDirectory('resources/vendor/datatables/jquery.dataTables.min.js', 'public/js').
 version();
 mix.copyDirectory('resources/vendor/datatables/dataTables.bootstrap4.min.js', 'public/js').version();
 mix.copyDirectory('resources/vendor/datatables/dataTables.buttons.min.js', 'public/js').version();
 mix.copyDirectory('resources/vendor/fontawesome-free/js/all.min.js', 'public/js').version();
 mix.copyDirectory('resources/vendor/printjs/print-this.js', 'public/js').version();
 mix.copyDirectory('resources/vendor/qrcode-scanner/html5-qrcode.min.js', 'public/js').version();
 mix.copyDirectory('resources/vendor/qrcode-scanner/html5-qrcode-2.3.8.min.js', 'public/js').version();
 mix.copyDirectory('resources/vendor/fontawesome-free/webfonts/', 'public/webfonts').version();
 mix.copyDirectory('resources/vendor/slick/slick.min.js', 'public/js').version();
 mix.copyDirectory('node_modules/toastr/toastr.js', 'public/js').version();
 mix.copyDirectory('resources/js/sb-admin-2.min.js', 'public/js').version();
 mix.copyDirectory('resources/img', 'public/img');

 mix.js(['resources/js/global.js','resources/js/utils.js'], 'public/js/core.js').version();

 //Core Styles
 mix.sass('resources/scss/sb-admin-2.scss', 'public/css').version();
 mix.sass('resources/scss/theme.scss', 'public/css').version();

 //Third Party
 mix.styles([
         'resources/vendor/fontawesome-free/css/all.min.css',
         'resources/vendor/datatables/dataTables.bootstrap4.min.css',
         'resources/vendor/slick/slick.scss',
         'node_modules/toastr/toastr.scss'
     ], 'public/css/thirdparty.css');

//Reusable components
 //Modules
 mix.copyDirectory('resources/js/components/*.js', 'public/js/components').version();
 mix.copyDirectory('resources/js/modules/*.js', 'public/js/modules').version();

