"use strict";const util=require("util"),qr=require("qr-image"),iconv=require("iconv-lite"),getPixels=require("get-pixels"),{MutableBuffer:MutableBuffer}=require("mutable-buffer"),EventEmitter=require("events"),Image=require("./image"),utils=require("./utils"),_=require("./commands"),Promiseify=require("./promisify"),statuses=require("./statuses"),{PrinterStatus:PrinterStatus,OfflineCauseStatus:OfflineCauseStatus,ErrorCauseStatus:ErrorCauseStatus,RollPaperSensorStatus:RollPaperSensorStatus}=statuses;function Printer(t,e){if(!(this instanceof Printer))return new Printer(t);EventEmitter.call(this),this.adapter=t,this.options=e,this.buffer=new MutableBuffer,this.encoding=e&&e.encoding||"GB18030",this.width=e&&e.width||48,this._model=null}Printer.create=function(t){const e=new Printer(t);return Promise.resolve(Promiseify(e))},util.inherits(Printer,EventEmitter),Printer.prototype.model=function(t){return this._model=t,this},Printer.prototype.setCharacterCodeTable=function(t){return this.buffer.write(_.ESC),this.buffer.write(_.TAB),this.buffer.writeUInt8(t),this},Printer.prototype.marginBottom=function(t){return this.buffer.write(_.MARGINS.BOTTOM),this.buffer.writeUInt8(t),this},Printer.prototype.marginLeft=function(t){return this.buffer.write(_.MARGINS.LEFT),this.buffer.writeUInt8(t),this},Printer.prototype.marginRight=function(t){return this.buffer.write(_.MARGINS.RIGHT),this.buffer.writeUInt8(t),this},Printer.prototype.print=function(t){return this.buffer.write(t),this},Printer.prototype.println=function(t){return this.print(t+_.EOL)},Printer.prototype.newLine=function(){return this.print(_.EOL)},Printer.prototype.text=function(t,e){return this.print(iconv.encode(t+_.EOL,e||this.encoding))},Printer.prototype.drawLine=function(){for(var t=0;t<this.width;t++)this.buffer.write(Buffer.from("-"));return this.newLine(),this},Printer.prototype.table=function(t,e){for(var r=this.width/t.length,i="",n=0;n<t.length;n++){i+=t[n].toString();for(var s=r-t[n].toString().length,T=0;T<s;T++)i+=" "}return this.buffer.write(iconv.encode(i+_.EOL,e||this.encoding)),this},Printer.prototype.tableCustom=function(t,e={}){e=e||{size:[],encoding:this.encoding};let[r=1,i=1]=e.size||[],n=Math.floor(this.width/r),s=Math.floor(n/t.length),T=n-s*t.length,o="",f=!1,u=[];for(let e=0;e<t.length;e++){let r=t[e],i=(r.align||"").toUpperCase(),_=!1;r.text=r.text.toString();let E=r.text.length;if(r.width?s=n*r.width:r.cols&&(s=r.cols),s<E&&(_=!0,r.originalText=r.text,r.text=r.text.substring(0,s)),"CENTER"===i){let t=(s-E)/2;for(let e=0;e<t;e++)o+=" ";""!==r.text&&(r.style?o+=this._getStyle(r.style)+r.text+this._getStyle("NORMAL"):o+=r.text);for(let e=0;e<t-1;e++)o+=" "}else if("RIGHT"===i){let t=s-E;T>0&&(t+=T,T=0);for(let e=0;e<t;e++)o+=" ";""!==r.text&&(r.style?o+=this._getStyle(r.style)+r.text+this._getStyle("NORMAL"):o+=r.text)}else{""!==r.text&&(r.style?o+=this._getStyle(r.style)+r.text+this._getStyle("NORMAL"):o+=r.text);let t=Math.floor(s-E);T>0&&(t+=T,T=0);for(let e=0;e<t;e++)o+=" "}_?(f=!0,r.text=r.originalText.substring(s),u.push(r)):(r.text="",u.push(r))}return(r>1||i>1)&&(o=_.TEXT_FORMAT.TXT_CUSTOM_SIZE(r,i)+o+_.TEXT_FORMAT.TXT_NORMAL),this.buffer.write(iconv.encode(o+_.EOL,e.encoding||this.encoding)),f?this.tableCustom(u,e):this},Printer.prototype.pureText=function(t,e){return this.print(iconv.encode(t,e||this.encoding))},Printer.prototype.encode=function(t){return this.encoding=t,this},Printer.prototype.feed=function(t){return this.buffer.write(new Array(t||1).fill(_.EOL).join("")),this},Printer.prototype.control=function(t){return this.buffer.write(_.FEED_CONTROL_SEQUENCES["CTL_"+t.toUpperCase()]),this},Printer.prototype.align=function(t){return this.buffer.write(_.TEXT_FORMAT["TXT_ALIGN_"+t.toUpperCase()]),this},Printer.prototype.font=function(t){return this.buffer.write(_.TEXT_FORMAT["TXT_FONT_"+t.toUpperCase()]),"A"===t.toUpperCase()?this.width=this.options&&this.options.width||42:this.width=this.options&&this.options.width||56,this},Printer.prototype._getStyle=function(t){let e="";switch(t.toUpperCase()){case"B":e+=_.TEXT_FORMAT.TXT_BOLD_ON,e+=_.TEXT_FORMAT.TXT_ITALIC_OFF,e+=_.TEXT_FORMAT.TXT_UNDERL_OFF;break;case"I":e+=_.TEXT_FORMAT.TXT_BOLD_OFF,e+=_.TEXT_FORMAT.TXT_ITALIC_ON,e+=_.TEXT_FORMAT.TXT_UNDERL_OFF;break;case"U":e+=_.TEXT_FORMAT.TXT_BOLD_OFF,e+=_.TEXT_FORMAT.TXT_ITALIC_OFF,e+=_.TEXT_FORMAT.TXT_UNDERL_ON;break;case"U2":e+=_.TEXT_FORMAT.TXT_BOLD_OFF,e+=_.TEXT_FORMAT.TXT_ITALIC_OFF,e+=_.TEXT_FORMAT.TXT_UNDERL2_ON;break;case"BI":e+=_.TEXT_FORMAT.TXT_BOLD_ON,e+=_.TEXT_FORMAT.TXT_ITALIC_ON,e+=_.TEXT_FORMAT.TXT_UNDERL_OFF;break;case"BIU":e+=_.TEXT_FORMAT.TXT_BOLD_ON,e+=_.TEXT_FORMAT.TXT_ITALIC_ON,e+=_.TEXT_FORMAT.TXT_UNDERL_ON;break;case"BIU2":e+=_.TEXT_FORMAT.TXT_BOLD_ON,e+=_.TEXT_FORMAT.TXT_ITALIC_ON,e+=_.TEXT_FORMAT.TXT_UNDERL2_ON;break;case"BU":e+=_.TEXT_FORMAT.TXT_BOLD_ON,e+=_.TEXT_FORMAT.TXT_ITALIC_OFF,e+=_.TEXT_FORMAT.TXT_UNDERL_ON;break;case"BU2":e+=_.TEXT_FORMAT.TXT_BOLD_ON,e+=_.TEXT_FORMAT.TXT_ITALIC_OFF,e+=_.TEXT_FORMAT.TXT_UNDERL2_ON;break;case"IU":e+=_.TEXT_FORMAT.TXT_BOLD_OFF,e+=_.TEXT_FORMAT.TXT_ITALIC_ON,e+=_.TEXT_FORMAT.TXT_UNDERL_ON;break;case"IU2":e+=_.TEXT_FORMAT.TXT_BOLD_OFF,e+=_.TEXT_FORMAT.TXT_ITALIC_ON,e+=_.TEXT_FORMAT.TXT_UNDERL2_ON;break;case"NORMAL":default:e+=_.TEXT_FORMAT.TXT_BOLD_OFF,e+=_.TEXT_FORMAT.TXT_ITALIC_OFF,e+=_.TEXT_FORMAT.TXT_UNDERL_OFF}return e},Printer.prototype.style=function(t){return this.buffer.write(this._getStyle(t)),this},Printer.prototype.size=function(t,e){return this.buffer.write(_.TEXT_FORMAT.TXT_CUSTOM_SIZE(t,e)),this},Printer.prototype.spacing=function(t){return void 0===t||null===t?this.buffer.write(_.CHARACTER_SPACING.CS_DEFAULT):(this.buffer.write(_.CHARACTER_SPACING.CS_SET),this.buffer.writeUInt8(t)),this},Printer.prototype.lineSpace=function(t){return void 0===t||null===t?this.buffer.write(_.LINE_SPACING.LS_DEFAULT):(this.buffer.write(_.LINE_SPACING.LS_SET),this.buffer.writeUInt8(t)),this},Printer.prototype.hardware=function(t){return this.buffer.write(_.HARDWARE["HW_"+t.toUpperCase()]),this},Printer.prototype.barcode=function(t,e,r){var i,n,s,T,o;r=r||{},"string"==typeof(i=arguments[2])||"number"==typeof i?(i=arguments[2],n=arguments[3],s=arguments[4],T=arguments[5]):(i=r.width,n=r.height,s=r.position,T=r.font,o=!1!==r.includeParity),e=e||"EAN13";var f=String(t),u="",E="";if(void 0===e||null===e)throw new TypeError("barcode type is required");if("EAN13"===e&&12!==f.length)throw new Error("EAN13 Barcode type requires code length 12");if("EAN8"===e&&7!==f.length)throw new Error("EAN8 Barcode type requires code length 7");return"qsprinter"===this._model&&this.buffer.write(_.MODEL.QSPRINTER.BARCODE_MODE.ON),"qsprinter"===this._model||(i>=1&&i<=5?this.buffer.write(_.BARCODE_FORMAT.BARCODE_WIDTH[i]):this.buffer.write(_.BARCODE_FORMAT.BARCODE_WIDTH_DEFAULT)),n>=1&&n<=255?this.buffer.write(_.BARCODE_FORMAT.BARCODE_HEIGHT(n)):"qsprinter"===this._model?this.buffer.write(_.MODEL.QSPRINTER.BARCODE_HEIGHT_DEFAULT):this.buffer.write(_.BARCODE_FORMAT.BARCODE_HEIGHT_DEFAULT),"qsprinter"===this._model||this.buffer.write(_.BARCODE_FORMAT["BARCODE_FONT_"+(T||"A").toUpperCase()]),this.buffer.write(_.BARCODE_FORMAT["BARCODE_TXT_"+(s||"BLW").toUpperCase()]),this.buffer.write(_.BARCODE_FORMAT["BARCODE_"+(e||"EAN13").replace("-","_").toUpperCase()]),o&&("EAN13"!==e&&"EAN8"!==e||(u=utils.getParityBit(t))),"CODE128"!=e&&"CODE93"!=e||(E=utils.codeLength(t)),this.buffer.write(E+t+(o?u:"")+"\0"),"qsprinter"===this._model&&this.buffer.write(_.MODEL.QSPRINTER.BARCODE_MODE.OFF),this},Printer.prototype.qrcode=function(t,e,r,i){if("qsprinter"!==this._model)this.buffer.write(_.CODE2D_FORMAT.TYPE_QR),this.buffer.write(_.CODE2D_FORMAT.CODE2D),this.buffer.writeUInt8(e||3),this.buffer.write(_.CODE2D_FORMAT["QR_LEVEL_"+(r||"L").toUpperCase()]),this.buffer.writeUInt8(i||6),this.buffer.writeUInt16LE(t.length),this.buffer.write(t);else{const n=iconv.encode(t,"utf8");if(n.length<1&&n.length>2710)throw new Error("Invalid code length in byte. Must be between 1 and 2710");!i||i&&"number"!=typeof i?i=_.MODEL.QSPRINTER.CODE2D_FORMAT.PIXEL_SIZE.DEFAULT:i&&i<_.MODEL.QSPRINTER.CODE2D_FORMAT.PIXEL_SIZE.MIN?i=_.MODEL.QSPRINTER.CODE2D_FORMAT.PIXEL_SIZE.MIN:i&&i>_.MODEL.QSPRINTER.CODE2D_FORMAT.PIXEL_SIZE.MAX&&(i=_.MODEL.QSPRINTER.CODE2D_FORMAT.PIXEL_SIZE.MAX),this.buffer.write(_.MODEL.QSPRINTER.CODE2D_FORMAT.PIXEL_SIZE.CMD),this.buffer.writeUInt8(i),!e||e&&"number"!=typeof e?e=_.MODEL.QSPRINTER.CODE2D_FORMAT.VERSION.DEFAULT:e&&e<_.MODEL.QSPRINTER.CODE2D_FORMAT.VERSION.MIN?e=_.MODEL.QSPRINTER.CODE2D_FORMAT.VERSION.MIN:e&&e>_.MODEL.QSPRINTER.CODE2D_FORMAT.VERSION.MAX&&(e=_.MODEL.QSPRINTER.CODE2D_FORMAT.VERSION.MAX),this.buffer.write(_.MODEL.QSPRINTER.CODE2D_FORMAT.VERSION.CMD),this.buffer.writeUInt8(e),(!r||r&&"string"!=typeof r)&&(r=_.CODE2D_FORMAT.QR_LEVEL_L),this.buffer.write(_.MODEL.QSPRINTER.CODE2D_FORMAT.LEVEL.CMD),this.buffer.write(_.MODEL.QSPRINTER.CODE2D_FORMAT.LEVEL.OPTIONS[r.toUpperCase()]),this.buffer.write(_.MODEL.QSPRINTER.CODE2D_FORMAT.SAVEBUF.CMD_P1),this.buffer.writeUInt16LE(n.length+_.MODEL.QSPRINTER.CODE2D_FORMAT.LEN_OFFSET),this.buffer.write(_.MODEL.QSPRINTER.CODE2D_FORMAT.SAVEBUF.CMD_P2),this.buffer.write(n),this.buffer.write(_.MODEL.QSPRINTER.CODE2D_FORMAT.PRINTBUF.CMD_P1),this.buffer.writeUInt16LE(n.length+_.MODEL.QSPRINTER.CODE2D_FORMAT.LEN_OFFSET),this.buffer.write(_.MODEL.QSPRINTER.CODE2D_FORMAT.PRINTBUF.CMD_P2)}return this},Printer.prototype.qrimage=function(t,e,r){var i=this;"function"==typeof e&&(r=e,e=null),e=e||{type:"png",mode:"dhdw"};var n=qr.imageSync(t,e),s=["image",e.type].join("/");return getPixels(n,s,function(t,n){if(t)return r&&r(t);i.raster(new Image(n),e.mode),r&&r.call(i,null,i)}),this},Printer.prototype.image=async function(t,e){if(!(t instanceof Image))throw new TypeError("Only escpos.Image supported");var r=~["d8","s8"].indexOf(e=e||"d24")?1:3,i=_.BITMAP_FORMAT["BITMAP_"+e.toUpperCase()],n=t.toBitmap(8*r),s=this;return this.lineSpace(0),n.data.forEach(async t=>{s.buffer.write(i),s.buffer.writeUInt16LE(t.length/r),s.buffer.write(t),s.buffer.write(_.EOL),await new Promise((t,e)=>{setTimeout(()=>{t(!0)},200)})}),this.lineSpace()},Printer.prototype.raster=function(t,e){if(!(t instanceof Image))throw new TypeError("Only escpos.Image supported");"dhdw"!==(e=e||"normal")&&"dwh"!==e&&"dhw"!==e||(e="dwdh");var r=t.toRaster(),i=_.GSV0_FORMAT["GSV0_"+e.toUpperCase()];return this.buffer.write(i),this.buffer.writeUInt16LE(r.width),this.buffer.writeUInt16LE(r.height),this.buffer.write(r.data),this},Printer.prototype.cashdraw=function(t){return this.buffer.write(_.CASH_DRAWER["CD_KICK_"+(t||2)]),this},Printer.prototype.beep=function(t,e){return this.buffer.write(_.BEEP),this.buffer.writeUInt8(t),this.buffer.writeUInt8(e),this},Printer.prototype.flush=function(t){var e=this.buffer.flush();return this.adapter.write(e,t),this},Printer.prototype.cut=function(t,e){return this.feed(e||3),this.buffer.write(_.PAPER[t?"PAPER_PART_CUT":"PAPER_FULL_CUT"]),this},Printer.prototype.close=function(t,e){var r=this;return this.flush(function(){r.adapter.close(t,e)})},Printer.prototype.color=function(t){return this.buffer.write(_.COLOR[0===t||1===t?t:0]),this},Printer.prototype.setReverseColors=function(t){return this.buffer.write(t?_.COLOR.REVERSE:_.COLOR.UNREVERSE),this},Printer.prototype.raw=function(t){return Buffer.isBuffer(t)?this.buffer.write(t):"string"==typeof t&&(t=t.toLowerCase(),this.buffer.write(Buffer.from(t.replace(/(\s|:)/g,""),"hex"))),this},Printer.prototype.getStatus=function(t,e){return this.adapter.read(r=>{const i=r.readInt8(0),n=new statuses[t](i);e(n)}),statuses[t].commands().forEach(t=>{this.buffer.write(t)}),this},Printer.prototype.getStatuses=function(t){let e=[];return this.adapter.read(r=>{for(let t=0;t<r.byteLength;t++)e.push(r.readInt8(t));if(e.length<4)return;let i=[];for(let t=0;t<e.length;t++){let r=e[t];switch(t){case 0:i.push(new PrinterStatus(r));break;case 1:i.push(new RollPaperSensorStatus(r));break;case 2:i.push(new OfflineCauseStatus(r));break;case 3:i.push(new ErrorCauseStatus(r))}}e=[],t(i)}),PrinterStatus.commands().forEach(t=>{this.adapter.write(t)}),RollPaperSensorStatus.commands().forEach(t=>{this.adapter.write(t)}),OfflineCauseStatus.commands().forEach(t=>{this.adapter.write(t)}),ErrorCauseStatus.commands().forEach(t=>{this.adapter.write(t)}),this},Printer.Printer=Printer,Printer.Image=require("./image"),Printer.command=require("./commands"),Printer.Printer2=require("./promisify"),module.exports=Printer;